(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
	typeof define === 'function' && define.amd ? define(['exports'], factory) :
	(factory((global['bootstrap-styled'] = {})));
}(this, (function (exports) { 'use strict';

	function unwrapExports (x) {
		return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x.default : x;
	}

	function createCommonjsModule(fn, module) {
		return module = { exports: {} }, fn(module, module.exports), module.exports;
	}

	var colorName = {
		"aliceblue": [240, 248, 255],
		"antiquewhite": [250, 235, 215],
		"aqua": [0, 255, 255],
		"aquamarine": [127, 255, 212],
		"azure": [240, 255, 255],
		"beige": [245, 245, 220],
		"bisque": [255, 228, 196],
		"black": [0, 0, 0],
		"blanchedalmond": [255, 235, 205],
		"blue": [0, 0, 255],
		"blueviolet": [138, 43, 226],
		"brown": [165, 42, 42],
		"burlywood": [222, 184, 135],
		"cadetblue": [95, 158, 160],
		"chartreuse": [127, 255, 0],
		"chocolate": [210, 105, 30],
		"coral": [255, 127, 80],
		"cornflowerblue": [100, 149, 237],
		"cornsilk": [255, 248, 220],
		"crimson": [220, 20, 60],
		"cyan": [0, 255, 255],
		"darkblue": [0, 0, 139],
		"darkcyan": [0, 139, 139],
		"darkgoldenrod": [184, 134, 11],
		"darkgray": [169, 169, 169],
		"darkgreen": [0, 100, 0],
		"darkgrey": [169, 169, 169],
		"darkkhaki": [189, 183, 107],
		"darkmagenta": [139, 0, 139],
		"darkolivegreen": [85, 107, 47],
		"darkorange": [255, 140, 0],
		"darkorchid": [153, 50, 204],
		"darkred": [139, 0, 0],
		"darksalmon": [233, 150, 122],
		"darkseagreen": [143, 188, 143],
		"darkslateblue": [72, 61, 139],
		"darkslategray": [47, 79, 79],
		"darkslategrey": [47, 79, 79],
		"darkturquoise": [0, 206, 209],
		"darkviolet": [148, 0, 211],
		"deeppink": [255, 20, 147],
		"deepskyblue": [0, 191, 255],
		"dimgray": [105, 105, 105],
		"dimgrey": [105, 105, 105],
		"dodgerblue": [30, 144, 255],
		"firebrick": [178, 34, 34],
		"floralwhite": [255, 250, 240],
		"forestgreen": [34, 139, 34],
		"fuchsia": [255, 0, 255],
		"gainsboro": [220, 220, 220],
		"ghostwhite": [248, 248, 255],
		"gold": [255, 215, 0],
		"goldenrod": [218, 165, 32],
		"gray": [128, 128, 128],
		"green": [0, 128, 0],
		"greenyellow": [173, 255, 47],
		"grey": [128, 128, 128],
		"honeydew": [240, 255, 240],
		"hotpink": [255, 105, 180],
		"indianred": [205, 92, 92],
		"indigo": [75, 0, 130],
		"ivory": [255, 255, 240],
		"khaki": [240, 230, 140],
		"lavender": [230, 230, 250],
		"lavenderblush": [255, 240, 245],
		"lawngreen": [124, 252, 0],
		"lemonchiffon": [255, 250, 205],
		"lightblue": [173, 216, 230],
		"lightcoral": [240, 128, 128],
		"lightcyan": [224, 255, 255],
		"lightgoldenrodyellow": [250, 250, 210],
		"lightgray": [211, 211, 211],
		"lightgreen": [144, 238, 144],
		"lightgrey": [211, 211, 211],
		"lightpink": [255, 182, 193],
		"lightsalmon": [255, 160, 122],
		"lightseagreen": [32, 178, 170],
		"lightskyblue": [135, 206, 250],
		"lightslategray": [119, 136, 153],
		"lightslategrey": [119, 136, 153],
		"lightsteelblue": [176, 196, 222],
		"lightyellow": [255, 255, 224],
		"lime": [0, 255, 0],
		"limegreen": [50, 205, 50],
		"linen": [250, 240, 230],
		"magenta": [255, 0, 255],
		"maroon": [128, 0, 0],
		"mediumaquamarine": [102, 205, 170],
		"mediumblue": [0, 0, 205],
		"mediumorchid": [186, 85, 211],
		"mediumpurple": [147, 112, 219],
		"mediumseagreen": [60, 179, 113],
		"mediumslateblue": [123, 104, 238],
		"mediumspringgreen": [0, 250, 154],
		"mediumturquoise": [72, 209, 204],
		"mediumvioletred": [199, 21, 133],
		"midnightblue": [25, 25, 112],
		"mintcream": [245, 255, 250],
		"mistyrose": [255, 228, 225],
		"moccasin": [255, 228, 181],
		"navajowhite": [255, 222, 173],
		"navy": [0, 0, 128],
		"oldlace": [253, 245, 230],
		"olive": [128, 128, 0],
		"olivedrab": [107, 142, 35],
		"orange": [255, 165, 0],
		"orangered": [255, 69, 0],
		"orchid": [218, 112, 214],
		"palegoldenrod": [238, 232, 170],
		"palegreen": [152, 251, 152],
		"paleturquoise": [175, 238, 238],
		"palevioletred": [219, 112, 147],
		"papayawhip": [255, 239, 213],
		"peachpuff": [255, 218, 185],
		"peru": [205, 133, 63],
		"pink": [255, 192, 203],
		"plum": [221, 160, 221],
		"powderblue": [176, 224, 230],
		"purple": [128, 0, 128],
		"rebeccapurple": [102, 51, 153],
		"red": [255, 0, 0],
		"rosybrown": [188, 143, 143],
		"royalblue": [65, 105, 225],
		"saddlebrown": [139, 69, 19],
		"salmon": [250, 128, 114],
		"sandybrown": [244, 164, 96],
		"seagreen": [46, 139, 87],
		"seashell": [255, 245, 238],
		"sienna": [160, 82, 45],
		"silver": [192, 192, 192],
		"skyblue": [135, 206, 235],
		"slateblue": [106, 90, 205],
		"slategray": [112, 128, 144],
		"slategrey": [112, 128, 144],
		"snow": [255, 250, 250],
		"springgreen": [0, 255, 127],
		"steelblue": [70, 130, 180],
		"tan": [210, 180, 140],
		"teal": [0, 128, 128],
		"thistle": [216, 191, 216],
		"tomato": [255, 99, 71],
		"turquoise": [64, 224, 208],
		"violet": [238, 130, 238],
		"wheat": [245, 222, 179],
		"white": [255, 255, 255],
		"whitesmoke": [245, 245, 245],
		"yellow": [255, 255, 0],
		"yellowgreen": [154, 205, 50]
	};

	var isArrayish = function isArrayish(obj) {
		if (!obj || typeof obj === 'string') {
			return false;
		}
		return obj instanceof Array || Array.isArray(obj) ||
			(obj.length >= 0 && (obj.splice instanceof Function ||
				(Object.getOwnPropertyDescriptor(obj, (obj.length - 1)) && obj.constructor.name !== 'String')));
	};

	var simpleSwizzle = createCommonjsModule(function (module) {
	var concat = Array.prototype.concat;
	var slice = Array.prototype.slice;
	var swizzle = module.exports = function swizzle(args) {
		var results = [];
		for (var i = 0, len = args.length; i < len; i++) {
			var arg = args[i];
			if (isArrayish(arg)) {
				results = concat.call(results, slice.call(arg));
			} else {
				results.push(arg);
			}
		}
		return results;
	};
	swizzle.wrap = function (fn) {
		return function () {
			return fn(swizzle(arguments));
		};
	};
	});

	var colorString = createCommonjsModule(function (module) {
	var reverseNames = {};
	for (var name in colorName) {
		if (colorName.hasOwnProperty(name)) {
			reverseNames[colorName[name]] = name;
		}
	}
	var cs = module.exports = {
		to: {},
		get: {}
	};
	cs.get = function (string) {
		var prefix = string.substring(0, 3).toLowerCase();
		var val;
		var model;
		switch (prefix) {
			case 'hsl':
				val = cs.get.hsl(string);
				model = 'hsl';
				break;
			case 'hwb':
				val = cs.get.hwb(string);
				model = 'hwb';
				break;
			default:
				val = cs.get.rgb(string);
				model = 'rgb';
				break;
		}
		if (!val) {
			return null;
		}
		return {model: model, value: val};
	};
	cs.get.rgb = function (string) {
		if (!string) {
			return null;
		}
		var abbr = /^#([a-f0-9]{3,4})$/i;
		var hex = /^#([a-f0-9]{6})([a-f0-9]{2})?$/i;
		var rgba = /^rgba?\(\s*([+-]?\d+)\s*,\s*([+-]?\d+)\s*,\s*([+-]?\d+)\s*(?:,\s*([+-]?[\d\.]+)\s*)?\)$/;
		var per = /^rgba?\(\s*([+-]?[\d\.]+)\%\s*,\s*([+-]?[\d\.]+)\%\s*,\s*([+-]?[\d\.]+)\%\s*(?:,\s*([+-]?[\d\.]+)\s*)?\)$/;
		var keyword = /(\D+)/;
		var rgb = [0, 0, 0, 1];
		var match;
		var i;
		var hexAlpha;
		if (match = string.match(hex)) {
			hexAlpha = match[2];
			match = match[1];
			for (i = 0; i < 3; i++) {
				var i2 = i * 2;
				rgb[i] = parseInt(match.slice(i2, i2 + 2), 16);
			}
			if (hexAlpha) {
				rgb[3] = Math.round((parseInt(hexAlpha, 16) / 255) * 100) / 100;
			}
		} else if (match = string.match(abbr)) {
			match = match[1];
			hexAlpha = match[3];
			for (i = 0; i < 3; i++) {
				rgb[i] = parseInt(match[i] + match[i], 16);
			}
			if (hexAlpha) {
				rgb[3] = Math.round((parseInt(hexAlpha + hexAlpha, 16) / 255) * 100) / 100;
			}
		} else if (match = string.match(rgba)) {
			for (i = 0; i < 3; i++) {
				rgb[i] = parseInt(match[i + 1], 0);
			}
			if (match[4]) {
				rgb[3] = parseFloat(match[4]);
			}
		} else if (match = string.match(per)) {
			for (i = 0; i < 3; i++) {
				rgb[i] = Math.round(parseFloat(match[i + 1]) * 2.55);
			}
			if (match[4]) {
				rgb[3] = parseFloat(match[4]);
			}
		} else if (match = string.match(keyword)) {
			if (match[1] === 'transparent') {
				return [0, 0, 0, 0];
			}
			rgb = colorName[match[1]];
			if (!rgb) {
				return null;
			}
			rgb[3] = 1;
			return rgb;
		} else {
			return null;
		}
		for (i = 0; i < 3; i++) {
			rgb[i] = clamp(rgb[i], 0, 255);
		}
		rgb[3] = clamp(rgb[3], 0, 1);
		return rgb;
	};
	cs.get.hsl = function (string) {
		if (!string) {
			return null;
		}
		var hsl = /^hsla?\(\s*([+-]?(?:\d*\.)?\d+)(?:deg)?\s*,\s*([+-]?[\d\.]+)%\s*,\s*([+-]?[\d\.]+)%\s*(?:,\s*([+-]?[\d\.]+)\s*)?\)$/;
		var match = string.match(hsl);
		if (match) {
			var alpha = parseFloat(match[4]);
			var h = (parseFloat(match[1]) + 360) % 360;
			var s = clamp(parseFloat(match[2]), 0, 100);
			var l = clamp(parseFloat(match[3]), 0, 100);
			var a = clamp(isNaN(alpha) ? 1 : alpha, 0, 1);
			return [h, s, l, a];
		}
		return null;
	};
	cs.get.hwb = function (string) {
		if (!string) {
			return null;
		}
		var hwb = /^hwb\(\s*([+-]?\d*[\.]?\d+)(?:deg)?\s*,\s*([+-]?[\d\.]+)%\s*,\s*([+-]?[\d\.]+)%\s*(?:,\s*([+-]?[\d\.]+)\s*)?\)$/;
		var match = string.match(hwb);
		if (match) {
			var alpha = parseFloat(match[4]);
			var h = ((parseFloat(match[1]) % 360) + 360) % 360;
			var w = clamp(parseFloat(match[2]), 0, 100);
			var b = clamp(parseFloat(match[3]), 0, 100);
			var a = clamp(isNaN(alpha) ? 1 : alpha, 0, 1);
			return [h, w, b, a];
		}
		return null;
	};
	cs.to.hex = function () {
		var rgba = simpleSwizzle(arguments);
		return (
			'#' +
			hexDouble(rgba[0]) +
			hexDouble(rgba[1]) +
			hexDouble(rgba[2]) +
			(rgba[3] < 1
				? (hexDouble(Math.round(rgba[3] * 255)))
				: '')
		);
	};
	cs.to.rgb = function () {
		var rgba = simpleSwizzle(arguments);
		return rgba.length < 4 || rgba[3] === 1
			? 'rgb(' + Math.round(rgba[0]) + ', ' + Math.round(rgba[1]) + ', ' + Math.round(rgba[2]) + ')'
			: 'rgba(' + Math.round(rgba[0]) + ', ' + Math.round(rgba[1]) + ', ' + Math.round(rgba[2]) + ', ' + rgba[3] + ')';
	};
	cs.to.rgb.percent = function () {
		var rgba = simpleSwizzle(arguments);
		var r = Math.round(rgba[0] / 255 * 100);
		var g = Math.round(rgba[1] / 255 * 100);
		var b = Math.round(rgba[2] / 255 * 100);
		return rgba.length < 4 || rgba[3] === 1
			? 'rgb(' + r + '%, ' + g + '%, ' + b + '%)'
			: 'rgba(' + r + '%, ' + g + '%, ' + b + '%, ' + rgba[3] + ')';
	};
	cs.to.hsl = function () {
		var hsla = simpleSwizzle(arguments);
		return hsla.length < 4 || hsla[3] === 1
			? 'hsl(' + hsla[0] + ', ' + hsla[1] + '%, ' + hsla[2] + '%)'
			: 'hsla(' + hsla[0] + ', ' + hsla[1] + '%, ' + hsla[2] + '%, ' + hsla[3] + ')';
	};
	cs.to.hwb = function () {
		var hwba = simpleSwizzle(arguments);
		var a = '';
		if (hwba.length >= 4 && hwba[3] !== 1) {
			a = ', ' + hwba[3];
		}
		return 'hwb(' + hwba[0] + ', ' + hwba[1] + '%, ' + hwba[2] + '%' + a + ')';
	};
	cs.to.keyword = function (rgb) {
		return reverseNames[rgb.slice(0, 3)];
	};
	function clamp(num, min, max) {
		return Math.min(Math.max(min, num), max);
	}
	function hexDouble(num) {
		var str = num.toString(16).toUpperCase();
		return (str.length < 2) ? '0' + str : str;
	}
	});
	var colorString_1 = colorString.to;
	var colorString_2 = colorString.get;

	var conversions = createCommonjsModule(function (module) {
	var reverseKeywords = {};
	for (var key in colorName) {
		if (colorName.hasOwnProperty(key)) {
			reverseKeywords[colorName[key]] = key;
		}
	}
	var convert = module.exports = {
		rgb: {channels: 3, labels: 'rgb'},
		hsl: {channels: 3, labels: 'hsl'},
		hsv: {channels: 3, labels: 'hsv'},
		hwb: {channels: 3, labels: 'hwb'},
		cmyk: {channels: 4, labels: 'cmyk'},
		xyz: {channels: 3, labels: 'xyz'},
		lab: {channels: 3, labels: 'lab'},
		lch: {channels: 3, labels: 'lch'},
		hex: {channels: 1, labels: ['hex']},
		keyword: {channels: 1, labels: ['keyword']},
		ansi16: {channels: 1, labels: ['ansi16']},
		ansi256: {channels: 1, labels: ['ansi256']},
		hcg: {channels: 3, labels: ['h', 'c', 'g']},
		apple: {channels: 3, labels: ['r16', 'g16', 'b16']},
		gray: {channels: 1, labels: ['gray']}
	};
	for (var model in convert) {
		if (convert.hasOwnProperty(model)) {
			if (!('channels' in convert[model])) {
				throw new Error('missing channels property: ' + model);
			}
			if (!('labels' in convert[model])) {
				throw new Error('missing channel labels property: ' + model);
			}
			if (convert[model].labels.length !== convert[model].channels) {
				throw new Error('channel and label counts mismatch: ' + model);
			}
			var channels = convert[model].channels;
			var labels = convert[model].labels;
			delete convert[model].channels;
			delete convert[model].labels;
			Object.defineProperty(convert[model], 'channels', {value: channels});
			Object.defineProperty(convert[model], 'labels', {value: labels});
		}
	}
	convert.rgb.hsl = function (rgb) {
		var r = rgb[0] / 255;
		var g = rgb[1] / 255;
		var b = rgb[2] / 255;
		var min = Math.min(r, g, b);
		var max = Math.max(r, g, b);
		var delta = max - min;
		var h;
		var s;
		var l;
		if (max === min) {
			h = 0;
		} else if (r === max) {
			h = (g - b) / delta;
		} else if (g === max) {
			h = 2 + (b - r) / delta;
		} else if (b === max) {
			h = 4 + (r - g) / delta;
		}
		h = Math.min(h * 60, 360);
		if (h < 0) {
			h += 360;
		}
		l = (min + max) / 2;
		if (max === min) {
			s = 0;
		} else if (l <= 0.5) {
			s = delta / (max + min);
		} else {
			s = delta / (2 - max - min);
		}
		return [h, s * 100, l * 100];
	};
	convert.rgb.hsv = function (rgb) {
		var rdif;
		var gdif;
		var bdif;
		var h;
		var s;
		var r = rgb[0] / 255;
		var g = rgb[1] / 255;
		var b = rgb[2] / 255;
		var v = Math.max(r, g, b);
		var diff = v - Math.min(r, g, b);
		var diffc = function (c) {
			return (v - c) / 6 / diff + 1 / 2;
		};
		if (diff === 0) {
			h = s = 0;
		} else {
			s = diff / v;
			rdif = diffc(r);
			gdif = diffc(g);
			bdif = diffc(b);
			if (r === v) {
				h = bdif - gdif;
			} else if (g === v) {
				h = (1 / 3) + rdif - bdif;
			} else if (b === v) {
				h = (2 / 3) + gdif - rdif;
			}
			if (h < 0) {
				h += 1;
			} else if (h > 1) {
				h -= 1;
			}
		}
		return [
			h * 360,
			s * 100,
			v * 100
		];
	};
	convert.rgb.hwb = function (rgb) {
		var r = rgb[0];
		var g = rgb[1];
		var b = rgb[2];
		var h = convert.rgb.hsl(rgb)[0];
		var w = 1 / 255 * Math.min(r, Math.min(g, b));
		b = 1 - 1 / 255 * Math.max(r, Math.max(g, b));
		return [h, w * 100, b * 100];
	};
	convert.rgb.cmyk = function (rgb) {
		var r = rgb[0] / 255;
		var g = rgb[1] / 255;
		var b = rgb[2] / 255;
		var c;
		var m;
		var y;
		var k;
		k = Math.min(1 - r, 1 - g, 1 - b);
		c = (1 - r - k) / (1 - k) || 0;
		m = (1 - g - k) / (1 - k) || 0;
		y = (1 - b - k) / (1 - k) || 0;
		return [c * 100, m * 100, y * 100, k * 100];
	};
	function comparativeDistance(x, y) {
		return (
			Math.pow(x[0] - y[0], 2) +
			Math.pow(x[1] - y[1], 2) +
			Math.pow(x[2] - y[2], 2)
		);
	}
	convert.rgb.keyword = function (rgb) {
		var reversed = reverseKeywords[rgb];
		if (reversed) {
			return reversed;
		}
		var currentClosestDistance = Infinity;
		var currentClosestKeyword;
		for (var keyword in colorName) {
			if (colorName.hasOwnProperty(keyword)) {
				var value = colorName[keyword];
				var distance = comparativeDistance(rgb, value);
				if (distance < currentClosestDistance) {
					currentClosestDistance = distance;
					currentClosestKeyword = keyword;
				}
			}
		}
		return currentClosestKeyword;
	};
	convert.keyword.rgb = function (keyword) {
		return colorName[keyword];
	};
	convert.rgb.xyz = function (rgb) {
		var r = rgb[0] / 255;
		var g = rgb[1] / 255;
		var b = rgb[2] / 255;
		r = r > 0.04045 ? Math.pow(((r + 0.055) / 1.055), 2.4) : (r / 12.92);
		g = g > 0.04045 ? Math.pow(((g + 0.055) / 1.055), 2.4) : (g / 12.92);
		b = b > 0.04045 ? Math.pow(((b + 0.055) / 1.055), 2.4) : (b / 12.92);
		var x = (r * 0.4124) + (g * 0.3576) + (b * 0.1805);
		var y = (r * 0.2126) + (g * 0.7152) + (b * 0.0722);
		var z = (r * 0.0193) + (g * 0.1192) + (b * 0.9505);
		return [x * 100, y * 100, z * 100];
	};
	convert.rgb.lab = function (rgb) {
		var xyz = convert.rgb.xyz(rgb);
		var x = xyz[0];
		var y = xyz[1];
		var z = xyz[2];
		var l;
		var a;
		var b;
		x /= 95.047;
		y /= 100;
		z /= 108.883;
		x = x > 0.008856 ? Math.pow(x, 1 / 3) : (7.787 * x) + (16 / 116);
		y = y > 0.008856 ? Math.pow(y, 1 / 3) : (7.787 * y) + (16 / 116);
		z = z > 0.008856 ? Math.pow(z, 1 / 3) : (7.787 * z) + (16 / 116);
		l = (116 * y) - 16;
		a = 500 * (x - y);
		b = 200 * (y - z);
		return [l, a, b];
	};
	convert.hsl.rgb = function (hsl) {
		var h = hsl[0] / 360;
		var s = hsl[1] / 100;
		var l = hsl[2] / 100;
		var t1;
		var t2;
		var t3;
		var rgb;
		var val;
		if (s === 0) {
			val = l * 255;
			return [val, val, val];
		}
		if (l < 0.5) {
			t2 = l * (1 + s);
		} else {
			t2 = l + s - l * s;
		}
		t1 = 2 * l - t2;
		rgb = [0, 0, 0];
		for (var i = 0; i < 3; i++) {
			t3 = h + 1 / 3 * -(i - 1);
			if (t3 < 0) {
				t3++;
			}
			if (t3 > 1) {
				t3--;
			}
			if (6 * t3 < 1) {
				val = t1 + (t2 - t1) * 6 * t3;
			} else if (2 * t3 < 1) {
				val = t2;
			} else if (3 * t3 < 2) {
				val = t1 + (t2 - t1) * (2 / 3 - t3) * 6;
			} else {
				val = t1;
			}
			rgb[i] = val * 255;
		}
		return rgb;
	};
	convert.hsl.hsv = function (hsl) {
		var h = hsl[0];
		var s = hsl[1] / 100;
		var l = hsl[2] / 100;
		var smin = s;
		var lmin = Math.max(l, 0.01);
		var sv;
		var v;
		l *= 2;
		s *= (l <= 1) ? l : 2 - l;
		smin *= lmin <= 1 ? lmin : 2 - lmin;
		v = (l + s) / 2;
		sv = l === 0 ? (2 * smin) / (lmin + smin) : (2 * s) / (l + s);
		return [h, sv * 100, v * 100];
	};
	convert.hsv.rgb = function (hsv) {
		var h = hsv[0] / 60;
		var s = hsv[1] / 100;
		var v = hsv[2] / 100;
		var hi = Math.floor(h) % 6;
		var f = h - Math.floor(h);
		var p = 255 * v * (1 - s);
		var q = 255 * v * (1 - (s * f));
		var t = 255 * v * (1 - (s * (1 - f)));
		v *= 255;
		switch (hi) {
			case 0:
				return [v, t, p];
			case 1:
				return [q, v, p];
			case 2:
				return [p, v, t];
			case 3:
				return [p, q, v];
			case 4:
				return [t, p, v];
			case 5:
				return [v, p, q];
		}
	};
	convert.hsv.hsl = function (hsv) {
		var h = hsv[0];
		var s = hsv[1] / 100;
		var v = hsv[2] / 100;
		var vmin = Math.max(v, 0.01);
		var lmin;
		var sl;
		var l;
		l = (2 - s) * v;
		lmin = (2 - s) * vmin;
		sl = s * vmin;
		sl /= (lmin <= 1) ? lmin : 2 - lmin;
		sl = sl || 0;
		l /= 2;
		return [h, sl * 100, l * 100];
	};
	convert.hwb.rgb = function (hwb) {
		var h = hwb[0] / 360;
		var wh = hwb[1] / 100;
		var bl = hwb[2] / 100;
		var ratio = wh + bl;
		var i;
		var v;
		var f;
		var n;
		if (ratio > 1) {
			wh /= ratio;
			bl /= ratio;
		}
		i = Math.floor(6 * h);
		v = 1 - bl;
		f = 6 * h - i;
		if ((i & 0x01) !== 0) {
			f = 1 - f;
		}
		n = wh + f * (v - wh);
		var r;
		var g;
		var b;
		switch (i) {
			default:
			case 6:
			case 0: r = v; g = n; b = wh; break;
			case 1: r = n; g = v; b = wh; break;
			case 2: r = wh; g = v; b = n; break;
			case 3: r = wh; g = n; b = v; break;
			case 4: r = n; g = wh; b = v; break;
			case 5: r = v; g = wh; b = n; break;
		}
		return [r * 255, g * 255, b * 255];
	};
	convert.cmyk.rgb = function (cmyk) {
		var c = cmyk[0] / 100;
		var m = cmyk[1] / 100;
		var y = cmyk[2] / 100;
		var k = cmyk[3] / 100;
		var r;
		var g;
		var b;
		r = 1 - Math.min(1, c * (1 - k) + k);
		g = 1 - Math.min(1, m * (1 - k) + k);
		b = 1 - Math.min(1, y * (1 - k) + k);
		return [r * 255, g * 255, b * 255];
	};
	convert.xyz.rgb = function (xyz) {
		var x = xyz[0] / 100;
		var y = xyz[1] / 100;
		var z = xyz[2] / 100;
		var r;
		var g;
		var b;
		r = (x * 3.2406) + (y * -1.5372) + (z * -0.4986);
		g = (x * -0.9689) + (y * 1.8758) + (z * 0.0415);
		b = (x * 0.0557) + (y * -0.2040) + (z * 1.0570);
		r = r > 0.0031308
			? ((1.055 * Math.pow(r, 1.0 / 2.4)) - 0.055)
			: r * 12.92;
		g = g > 0.0031308
			? ((1.055 * Math.pow(g, 1.0 / 2.4)) - 0.055)
			: g * 12.92;
		b = b > 0.0031308
			? ((1.055 * Math.pow(b, 1.0 / 2.4)) - 0.055)
			: b * 12.92;
		r = Math.min(Math.max(0, r), 1);
		g = Math.min(Math.max(0, g), 1);
		b = Math.min(Math.max(0, b), 1);
		return [r * 255, g * 255, b * 255];
	};
	convert.xyz.lab = function (xyz) {
		var x = xyz[0];
		var y = xyz[1];
		var z = xyz[2];
		var l;
		var a;
		var b;
		x /= 95.047;
		y /= 100;
		z /= 108.883;
		x = x > 0.008856 ? Math.pow(x, 1 / 3) : (7.787 * x) + (16 / 116);
		y = y > 0.008856 ? Math.pow(y, 1 / 3) : (7.787 * y) + (16 / 116);
		z = z > 0.008856 ? Math.pow(z, 1 / 3) : (7.787 * z) + (16 / 116);
		l = (116 * y) - 16;
		a = 500 * (x - y);
		b = 200 * (y - z);
		return [l, a, b];
	};
	convert.lab.xyz = function (lab) {
		var l = lab[0];
		var a = lab[1];
		var b = lab[2];
		var x;
		var y;
		var z;
		y = (l + 16) / 116;
		x = a / 500 + y;
		z = y - b / 200;
		var y2 = Math.pow(y, 3);
		var x2 = Math.pow(x, 3);
		var z2 = Math.pow(z, 3);
		y = y2 > 0.008856 ? y2 : (y - 16 / 116) / 7.787;
		x = x2 > 0.008856 ? x2 : (x - 16 / 116) / 7.787;
		z = z2 > 0.008856 ? z2 : (z - 16 / 116) / 7.787;
		x *= 95.047;
		y *= 100;
		z *= 108.883;
		return [x, y, z];
	};
	convert.lab.lch = function (lab) {
		var l = lab[0];
		var a = lab[1];
		var b = lab[2];
		var hr;
		var h;
		var c;
		hr = Math.atan2(b, a);
		h = hr * 360 / 2 / Math.PI;
		if (h < 0) {
			h += 360;
		}
		c = Math.sqrt(a * a + b * b);
		return [l, c, h];
	};
	convert.lch.lab = function (lch) {
		var l = lch[0];
		var c = lch[1];
		var h = lch[2];
		var a;
		var b;
		var hr;
		hr = h / 360 * 2 * Math.PI;
		a = c * Math.cos(hr);
		b = c * Math.sin(hr);
		return [l, a, b];
	};
	convert.rgb.ansi16 = function (args) {
		var r = args[0];
		var g = args[1];
		var b = args[2];
		var value = 1 in arguments ? arguments[1] : convert.rgb.hsv(args)[2];
		value = Math.round(value / 50);
		if (value === 0) {
			return 30;
		}
		var ansi = 30
			+ ((Math.round(b / 255) << 2)
			| (Math.round(g / 255) << 1)
			| Math.round(r / 255));
		if (value === 2) {
			ansi += 60;
		}
		return ansi;
	};
	convert.hsv.ansi16 = function (args) {
		return convert.rgb.ansi16(convert.hsv.rgb(args), args[2]);
	};
	convert.rgb.ansi256 = function (args) {
		var r = args[0];
		var g = args[1];
		var b = args[2];
		if (r === g && g === b) {
			if (r < 8) {
				return 16;
			}
			if (r > 248) {
				return 231;
			}
			return Math.round(((r - 8) / 247) * 24) + 232;
		}
		var ansi = 16
			+ (36 * Math.round(r / 255 * 5))
			+ (6 * Math.round(g / 255 * 5))
			+ Math.round(b / 255 * 5);
		return ansi;
	};
	convert.ansi16.rgb = function (args) {
		var color = args % 10;
		if (color === 0 || color === 7) {
			if (args > 50) {
				color += 3.5;
			}
			color = color / 10.5 * 255;
			return [color, color, color];
		}
		var mult = (~~(args > 50) + 1) * 0.5;
		var r = ((color & 1) * mult) * 255;
		var g = (((color >> 1) & 1) * mult) * 255;
		var b = (((color >> 2) & 1) * mult) * 255;
		return [r, g, b];
	};
	convert.ansi256.rgb = function (args) {
		if (args >= 232) {
			var c = (args - 232) * 10 + 8;
			return [c, c, c];
		}
		args -= 16;
		var rem;
		var r = Math.floor(args / 36) / 5 * 255;
		var g = Math.floor((rem = args % 36) / 6) / 5 * 255;
		var b = (rem % 6) / 5 * 255;
		return [r, g, b];
	};
	convert.rgb.hex = function (args) {
		var integer = ((Math.round(args[0]) & 0xFF) << 16)
			+ ((Math.round(args[1]) & 0xFF) << 8)
			+ (Math.round(args[2]) & 0xFF);
		var string = integer.toString(16).toUpperCase();
		return '000000'.substring(string.length) + string;
	};
	convert.hex.rgb = function (args) {
		var match = args.toString(16).match(/[a-f0-9]{6}|[a-f0-9]{3}/i);
		if (!match) {
			return [0, 0, 0];
		}
		var colorString = match[0];
		if (match[0].length === 3) {
			colorString = colorString.split('').map(function (char) {
				return char + char;
			}).join('');
		}
		var integer = parseInt(colorString, 16);
		var r = (integer >> 16) & 0xFF;
		var g = (integer >> 8) & 0xFF;
		var b = integer & 0xFF;
		return [r, g, b];
	};
	convert.rgb.hcg = function (rgb) {
		var r = rgb[0] / 255;
		var g = rgb[1] / 255;
		var b = rgb[2] / 255;
		var max = Math.max(Math.max(r, g), b);
		var min = Math.min(Math.min(r, g), b);
		var chroma = (max - min);
		var grayscale;
		var hue;
		if (chroma < 1) {
			grayscale = min / (1 - chroma);
		} else {
			grayscale = 0;
		}
		if (chroma <= 0) {
			hue = 0;
		} else
		if (max === r) {
			hue = ((g - b) / chroma) % 6;
		} else
		if (max === g) {
			hue = 2 + (b - r) / chroma;
		} else {
			hue = 4 + (r - g) / chroma + 4;
		}
		hue /= 6;
		hue %= 1;
		return [hue * 360, chroma * 100, grayscale * 100];
	};
	convert.hsl.hcg = function (hsl) {
		var s = hsl[1] / 100;
		var l = hsl[2] / 100;
		var c = 1;
		var f = 0;
		if (l < 0.5) {
			c = 2.0 * s * l;
		} else {
			c = 2.0 * s * (1.0 - l);
		}
		if (c < 1.0) {
			f = (l - 0.5 * c) / (1.0 - c);
		}
		return [hsl[0], c * 100, f * 100];
	};
	convert.hsv.hcg = function (hsv) {
		var s = hsv[1] / 100;
		var v = hsv[2] / 100;
		var c = s * v;
		var f = 0;
		if (c < 1.0) {
			f = (v - c) / (1 - c);
		}
		return [hsv[0], c * 100, f * 100];
	};
	convert.hcg.rgb = function (hcg) {
		var h = hcg[0] / 360;
		var c = hcg[1] / 100;
		var g = hcg[2] / 100;
		if (c === 0.0) {
			return [g * 255, g * 255, g * 255];
		}
		var pure = [0, 0, 0];
		var hi = (h % 1) * 6;
		var v = hi % 1;
		var w = 1 - v;
		var mg = 0;
		switch (Math.floor(hi)) {
			case 0:
				pure[0] = 1; pure[1] = v; pure[2] = 0; break;
			case 1:
				pure[0] = w; pure[1] = 1; pure[2] = 0; break;
			case 2:
				pure[0] = 0; pure[1] = 1; pure[2] = v; break;
			case 3:
				pure[0] = 0; pure[1] = w; pure[2] = 1; break;
			case 4:
				pure[0] = v; pure[1] = 0; pure[2] = 1; break;
			default:
				pure[0] = 1; pure[1] = 0; pure[2] = w;
		}
		mg = (1.0 - c) * g;
		return [
			(c * pure[0] + mg) * 255,
			(c * pure[1] + mg) * 255,
			(c * pure[2] + mg) * 255
		];
	};
	convert.hcg.hsv = function (hcg) {
		var c = hcg[1] / 100;
		var g = hcg[2] / 100;
		var v = c + g * (1.0 - c);
		var f = 0;
		if (v > 0.0) {
			f = c / v;
		}
		return [hcg[0], f * 100, v * 100];
	};
	convert.hcg.hsl = function (hcg) {
		var c = hcg[1] / 100;
		var g = hcg[2] / 100;
		var l = g * (1.0 - c) + 0.5 * c;
		var s = 0;
		if (l > 0.0 && l < 0.5) {
			s = c / (2 * l);
		} else
		if (l >= 0.5 && l < 1.0) {
			s = c / (2 * (1 - l));
		}
		return [hcg[0], s * 100, l * 100];
	};
	convert.hcg.hwb = function (hcg) {
		var c = hcg[1] / 100;
		var g = hcg[2] / 100;
		var v = c + g * (1.0 - c);
		return [hcg[0], (v - c) * 100, (1 - v) * 100];
	};
	convert.hwb.hcg = function (hwb) {
		var w = hwb[1] / 100;
		var b = hwb[2] / 100;
		var v = 1 - b;
		var c = v - w;
		var g = 0;
		if (c < 1) {
			g = (v - c) / (1 - c);
		}
		return [hwb[0], c * 100, g * 100];
	};
	convert.apple.rgb = function (apple) {
		return [(apple[0] / 65535) * 255, (apple[1] / 65535) * 255, (apple[2] / 65535) * 255];
	};
	convert.rgb.apple = function (rgb) {
		return [(rgb[0] / 255) * 65535, (rgb[1] / 255) * 65535, (rgb[2] / 255) * 65535];
	};
	convert.gray.rgb = function (args) {
		return [args[0] / 100 * 255, args[0] / 100 * 255, args[0] / 100 * 255];
	};
	convert.gray.hsl = convert.gray.hsv = function (args) {
		return [0, 0, args[0]];
	};
	convert.gray.hwb = function (gray) {
		return [0, 100, gray[0]];
	};
	convert.gray.cmyk = function (gray) {
		return [0, 0, 0, gray[0]];
	};
	convert.gray.lab = function (gray) {
		return [gray[0], 0, 0];
	};
	convert.gray.hex = function (gray) {
		var val = Math.round(gray[0] / 100 * 255) & 0xFF;
		var integer = (val << 16) + (val << 8) + val;
		var string = integer.toString(16).toUpperCase();
		return '000000'.substring(string.length) + string;
	};
	convert.rgb.gray = function (rgb) {
		var val = (rgb[0] + rgb[1] + rgb[2]) / 3;
		return [val / 255 * 100];
	};
	});
	var conversions_1 = conversions.rgb;
	var conversions_2 = conversions.hsl;
	var conversions_3 = conversions.hsv;
	var conversions_4 = conversions.hwb;
	var conversions_5 = conversions.cmyk;
	var conversions_6 = conversions.xyz;
	var conversions_7 = conversions.lab;
	var conversions_8 = conversions.lch;
	var conversions_9 = conversions.hex;
	var conversions_10 = conversions.keyword;
	var conversions_11 = conversions.ansi16;
	var conversions_12 = conversions.ansi256;
	var conversions_13 = conversions.hcg;
	var conversions_14 = conversions.apple;
	var conversions_15 = conversions.gray;

	function buildGraph() {
		var graph = {};
		var models = Object.keys(conversions);
		for (var len = models.length, i = 0; i < len; i++) {
			graph[models[i]] = {
				distance: -1,
				parent: null
			};
		}
		return graph;
	}
	function deriveBFS(fromModel) {
		var graph = buildGraph();
		var queue = [fromModel];
		graph[fromModel].distance = 0;
		while (queue.length) {
			var current = queue.pop();
			var adjacents = Object.keys(conversions[current]);
			for (var len = adjacents.length, i = 0; i < len; i++) {
				var adjacent = adjacents[i];
				var node = graph[adjacent];
				if (node.distance === -1) {
					node.distance = graph[current].distance + 1;
					node.parent = current;
					queue.unshift(adjacent);
				}
			}
		}
		return graph;
	}
	function link(from, to) {
		return function (args) {
			return to(from(args));
		};
	}
	function wrapConversion(toModel, graph) {
		var path = [graph[toModel].parent, toModel];
		var fn = conversions[graph[toModel].parent][toModel];
		var cur = graph[toModel].parent;
		while (graph[cur].parent) {
			path.unshift(graph[cur].parent);
			fn = link(conversions[graph[cur].parent][cur], fn);
			cur = graph[cur].parent;
		}
		fn.conversion = path;
		return fn;
	}
	var route = function (fromModel) {
		var graph = deriveBFS(fromModel);
		var conversion = {};
		var models = Object.keys(graph);
		for (var len = models.length, i = 0; i < len; i++) {
			var toModel = models[i];
			var node = graph[toModel];
			if (node.parent === null) {
				continue;
			}
			conversion[toModel] = wrapConversion(toModel, graph);
		}
		return conversion;
	};

	var convert = {};
	var models = Object.keys(conversions);
	function wrapRaw(fn) {
		var wrappedFn = function (args) {
			if (args === undefined || args === null) {
				return args;
			}
			if (arguments.length > 1) {
				args = Array.prototype.slice.call(arguments);
			}
			return fn(args);
		};
		if ('conversion' in fn) {
			wrappedFn.conversion = fn.conversion;
		}
		return wrappedFn;
	}
	function wrapRounded(fn) {
		var wrappedFn = function (args) {
			if (args === undefined || args === null) {
				return args;
			}
			if (arguments.length > 1) {
				args = Array.prototype.slice.call(arguments);
			}
			var result = fn(args);
			if (typeof result === 'object') {
				for (var len = result.length, i = 0; i < len; i++) {
					result[i] = Math.round(result[i]);
				}
			}
			return result;
		};
		if ('conversion' in fn) {
			wrappedFn.conversion = fn.conversion;
		}
		return wrappedFn;
	}
	models.forEach(function (fromModel) {
		convert[fromModel] = {};
		Object.defineProperty(convert[fromModel], 'channels', {value: conversions[fromModel].channels});
		Object.defineProperty(convert[fromModel], 'labels', {value: conversions[fromModel].labels});
		var routes = route(fromModel);
		var routeModels = Object.keys(routes);
		routeModels.forEach(function (toModel) {
			var fn = routes[toModel];
			convert[fromModel][toModel] = wrapRounded(fn);
			convert[fromModel][toModel].raw = wrapRaw(fn);
		});
	});
	var colorConvert = convert;

	var _slice = [].slice;
	var skippedModels = [
		'keyword',
		'gray',
		'hex'
	];
	var hashedModelKeys = {};
	Object.keys(colorConvert).forEach(function (model) {
		hashedModelKeys[_slice.call(colorConvert[model].labels).sort().join('')] = model;
	});
	var limiters = {};
	function Color(obj, model) {
		if (!(this instanceof Color)) {
			return new Color(obj, model);
		}
		if (model && model in skippedModels) {
			model = null;
		}
		if (model && !(model in colorConvert)) {
			throw new Error('Unknown model: ' + model);
		}
		var i;
		var channels;
		if (!obj) {
			this.model = 'rgb';
			this.color = [0, 0, 0];
			this.valpha = 1;
		} else if (obj instanceof Color) {
			this.model = obj.model;
			this.color = obj.color.slice();
			this.valpha = obj.valpha;
		} else if (typeof obj === 'string') {
			var result = colorString.get(obj);
			if (result === null) {
				throw new Error('Unable to parse color from string: ' + obj);
			}
			this.model = result.model;
			channels = colorConvert[this.model].channels;
			this.color = result.value.slice(0, channels);
			this.valpha = typeof result.value[channels] === 'number' ? result.value[channels] : 1;
		} else if (obj.length) {
			this.model = model || 'rgb';
			channels = colorConvert[this.model].channels;
			var newArr = _slice.call(obj, 0, channels);
			this.color = zeroArray(newArr, channels);
			this.valpha = typeof obj[channels] === 'number' ? obj[channels] : 1;
		} else if (typeof obj === 'number') {
			obj &= 0xFFFFFF;
			this.model = 'rgb';
			this.color = [
				(obj >> 16) & 0xFF,
				(obj >> 8) & 0xFF,
				obj & 0xFF
			];
			this.valpha = 1;
		} else {
			this.valpha = 1;
			var keys = Object.keys(obj);
			if ('alpha' in obj) {
				keys.splice(keys.indexOf('alpha'), 1);
				this.valpha = typeof obj.alpha === 'number' ? obj.alpha : 0;
			}
			var hashedKeys = keys.sort().join('');
			if (!(hashedKeys in hashedModelKeys)) {
				throw new Error('Unable to parse color from object: ' + JSON.stringify(obj));
			}
			this.model = hashedModelKeys[hashedKeys];
			var labels = colorConvert[this.model].labels;
			var color = [];
			for (i = 0; i < labels.length; i++) {
				color.push(obj[labels[i]]);
			}
			this.color = zeroArray(color);
		}
		if (limiters[this.model]) {
			channels = colorConvert[this.model].channels;
			for (i = 0; i < channels; i++) {
				var limit = limiters[this.model][i];
				if (limit) {
					this.color[i] = limit(this.color[i]);
				}
			}
		}
		this.valpha = Math.max(0, Math.min(1, this.valpha));
		if (Object.freeze) {
			Object.freeze(this);
		}
	}
	Color.prototype = {
		toString: function () {
			return this.string();
		},
		toJSON: function () {
			return this[this.model]();
		},
		string: function (places) {
			var self = this.model in colorString.to ? this : this.rgb();
			self = self.round(typeof places === 'number' ? places : 1);
			var args = self.valpha === 1 ? self.color : self.color.concat(this.valpha);
			return colorString.to[self.model](args);
		},
		percentString: function (places) {
			var self = this.rgb().round(typeof places === 'number' ? places : 1);
			var args = self.valpha === 1 ? self.color : self.color.concat(this.valpha);
			return colorString.to.rgb.percent(args);
		},
		array: function () {
			return this.valpha === 1 ? this.color.slice() : this.color.concat(this.valpha);
		},
		object: function () {
			var result = {};
			var channels = colorConvert[this.model].channels;
			var labels = colorConvert[this.model].labels;
			for (var i = 0; i < channels; i++) {
				result[labels[i]] = this.color[i];
			}
			if (this.valpha !== 1) {
				result.alpha = this.valpha;
			}
			return result;
		},
		unitArray: function () {
			var rgb = this.rgb().color;
			rgb[0] /= 255;
			rgb[1] /= 255;
			rgb[2] /= 255;
			if (this.valpha !== 1) {
				rgb.push(this.valpha);
			}
			return rgb;
		},
		unitObject: function () {
			var rgb = this.rgb().object();
			rgb.r /= 255;
			rgb.g /= 255;
			rgb.b /= 255;
			if (this.valpha !== 1) {
				rgb.alpha = this.valpha;
			}
			return rgb;
		},
		round: function (places) {
			places = Math.max(places || 0, 0);
			return new Color(this.color.map(roundToPlace(places)).concat(this.valpha), this.model);
		},
		alpha: function (val) {
			if (arguments.length) {
				return new Color(this.color.concat(Math.max(0, Math.min(1, val))), this.model);
			}
			return this.valpha;
		},
		red: getset('rgb', 0, maxfn(255)),
		green: getset('rgb', 1, maxfn(255)),
		blue: getset('rgb', 2, maxfn(255)),
		hue: getset(['hsl', 'hsv', 'hsl', 'hwb', 'hcg'], 0, function (val) { return ((val % 360) + 360) % 360; }),
		saturationl: getset('hsl', 1, maxfn(100)),
		lightness: getset('hsl', 2, maxfn(100)),
		saturationv: getset('hsv', 1, maxfn(100)),
		value: getset('hsv', 2, maxfn(100)),
		chroma: getset('hcg', 1, maxfn(100)),
		gray: getset('hcg', 2, maxfn(100)),
		white: getset('hwb', 1, maxfn(100)),
		wblack: getset('hwb', 2, maxfn(100)),
		cyan: getset('cmyk', 0, maxfn(100)),
		magenta: getset('cmyk', 1, maxfn(100)),
		yellow: getset('cmyk', 2, maxfn(100)),
		black: getset('cmyk', 3, maxfn(100)),
		x: getset('xyz', 0, maxfn(100)),
		y: getset('xyz', 1, maxfn(100)),
		z: getset('xyz', 2, maxfn(100)),
		l: getset('lab', 0, maxfn(100)),
		a: getset('lab', 1),
		b: getset('lab', 2),
		keyword: function (val) {
			if (arguments.length) {
				return new Color(val);
			}
			return colorConvert[this.model].keyword(this.color);
		},
		hex: function (val) {
			if (arguments.length) {
				return new Color(val);
			}
			return colorString.to.hex(this.rgb().round().color);
		},
		rgbNumber: function () {
			var rgb = this.rgb().color;
			return ((rgb[0] & 0xFF) << 16) | ((rgb[1] & 0xFF) << 8) | (rgb[2] & 0xFF);
		},
		luminosity: function () {
			var rgb = this.rgb().color;
			var lum = [];
			for (var i = 0; i < rgb.length; i++) {
				var chan = rgb[i] / 255;
				lum[i] = (chan <= 0.03928) ? chan / 12.92 : Math.pow(((chan + 0.055) / 1.055), 2.4);
			}
			return 0.2126 * lum[0] + 0.7152 * lum[1] + 0.0722 * lum[2];
		},
		contrast: function (color2) {
			var lum1 = this.luminosity();
			var lum2 = color2.luminosity();
			if (lum1 > lum2) {
				return (lum1 + 0.05) / (lum2 + 0.05);
			}
			return (lum2 + 0.05) / (lum1 + 0.05);
		},
		level: function (color2) {
			var contrastRatio = this.contrast(color2);
			if (contrastRatio >= 7.1) {
				return 'AAA';
			}
			return (contrastRatio >= 4.5) ? 'AA' : '';
		},
		dark: function () {
			var rgb = this.rgb().color;
			var yiq = (rgb[0] * 299 + rgb[1] * 587 + rgb[2] * 114) / 1000;
			return yiq < 128;
		},
		light: function () {
			return !this.dark();
		},
		negate: function () {
			var rgb = this.rgb();
			for (var i = 0; i < 3; i++) {
				rgb.color[i] = 255 - rgb.color[i];
			}
			return rgb;
		},
		lighten: function (ratio) {
			var hsl = this.hsl();
			hsl.color[2] += hsl.color[2] * ratio;
			return hsl;
		},
		darken: function (ratio) {
			var hsl = this.hsl();
			hsl.color[2] -= hsl.color[2] * ratio;
			return hsl;
		},
		saturate: function (ratio) {
			var hsl = this.hsl();
			hsl.color[1] += hsl.color[1] * ratio;
			return hsl;
		},
		desaturate: function (ratio) {
			var hsl = this.hsl();
			hsl.color[1] -= hsl.color[1] * ratio;
			return hsl;
		},
		whiten: function (ratio) {
			var hwb = this.hwb();
			hwb.color[1] += hwb.color[1] * ratio;
			return hwb;
		},
		blacken: function (ratio) {
			var hwb = this.hwb();
			hwb.color[2] += hwb.color[2] * ratio;
			return hwb;
		},
		grayscale: function () {
			var rgb = this.rgb().color;
			var val = rgb[0] * 0.3 + rgb[1] * 0.59 + rgb[2] * 0.11;
			return Color.rgb(val, val, val);
		},
		fade: function (ratio) {
			return this.alpha(this.valpha - (this.valpha * ratio));
		},
		opaquer: function (ratio) {
			return this.alpha(this.valpha + (this.valpha * ratio));
		},
		rotate: function (degrees) {
			var hsl = this.hsl();
			var hue = hsl.color[0];
			hue = (hue + degrees) % 360;
			hue = hue < 0 ? 360 + hue : hue;
			hsl.color[0] = hue;
			return hsl;
		},
		mix: function (mixinColor, weight) {
			var color1 = this.rgb();
			var color2 = mixinColor.rgb();
			var p = weight === undefined ? 0.5 : weight;
			var w = 2 * p - 1;
			var a = color1.alpha() - color2.alpha();
			var w1 = (((w * a === -1) ? w : (w + a) / (1 + w * a)) + 1) / 2.0;
			var w2 = 1 - w1;
			return Color.rgb(
					w1 * color1.red() + w2 * color2.red(),
					w1 * color1.green() + w2 * color2.green(),
					w1 * color1.blue() + w2 * color2.blue(),
					color1.alpha() * p + color2.alpha() * (1 - p));
		}
	};
	Object.keys(colorConvert).forEach(function (model) {
		if (skippedModels.indexOf(model) !== -1) {
			return;
		}
		var channels = colorConvert[model].channels;
		Color.prototype[model] = function () {
			if (this.model === model) {
				return new Color(this);
			}
			if (arguments.length) {
				return new Color(arguments, model);
			}
			var newAlpha = typeof arguments[channels] === 'number' ? channels : this.valpha;
			return new Color(assertArray(colorConvert[this.model][model].raw(this.color)).concat(newAlpha), model);
		};
		Color[model] = function (color) {
			if (typeof color === 'number') {
				color = zeroArray(_slice.call(arguments), channels);
			}
			return new Color(color, model);
		};
	});
	function roundTo(num, places) {
		return Number(num.toFixed(places));
	}
	function roundToPlace(places) {
		return function (num) {
			return roundTo(num, places);
		};
	}
	function getset(model, channel, modifier) {
		model = Array.isArray(model) ? model : [model];
		model.forEach(function (m) {
			(limiters[m] || (limiters[m] = []))[channel] = modifier;
		});
		model = model[0];
		return function (val) {
			var result;
			if (arguments.length) {
				if (modifier) {
					val = modifier(val);
				}
				result = this[model]();
				result.color[channel] = val;
				return result;
			}
			result = this[model]().color[channel];
			if (modifier) {
				result = modifier(result);
			}
			return result;
		};
	}
	function maxfn(max) {
		return function (v) {
			return Math.max(0, Math.min(max, v));
		};
	}
	function assertArray(val) {
		return Array.isArray(val) ? val : [val];
	}
	function zeroArray(arr, length) {
		for (var i = 0; i < length; i++) {
			if (typeof arr[i] !== 'number') {
				arr[i] = 0;
			}
		}
		return arr;
	}
	var color = Color;

	var unitUtils = createCommonjsModule(function (module, exports) {
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
	var UnitUtils = function UnitUtils() {
	  var _this = this;
	  _classCallCheck(this, UnitUtils);
	  this.UNIT = {
	    EM: 'em',
	    REM: 'rem',
	    PX: 'px',
	    PERCENT: '%'
	  };
	  this.math = {
	    addition: function addition(a, b) {
	      var unit = this.detectUnit(a) || this.detectUnit(b);
	      return this.rmUnit(a) + this.rmUnit(b) + unit;
	    }.bind(this),
	    subtract: function subtract(a, b) {
	      var unit = this.detectUnit(a) || this.detectUnit(b);
	      return this.rmUnit(a) - this.rmUnit(b) + unit;
	    }.bind(this),
	    multiply: function multiply(a, b) {
	      var unit = this.detectUnit(a) || this.detectUnit(b);
	      return this.rmUnit(a) * this.rmUnit(b) + unit;
	    }.bind(this),
	    divide: function divide(a, b) {
	      var unit = this.detectUnit(a) || this.detectUnit(b);
	      return this.rmUnit(a) / this.rmUnit(b) + unit;
	    }.bind(this)
	  };
	  this.detectUnit = function (value) {
	    var ext = void 0;
	    var valueStr = value.toString();
	    if (valueStr.match(_this.UNIT.PX)) {
	      ext = _this.UNIT.PX;
	    } else if (valueStr.match(_this.UNIT.REM)) {
	      ext = _this.UNIT.REM;
	    } else if (valueStr.match(_this.UNIT.EM)) {
	      ext = _this.UNIT.EM;
	    } else if (valueStr.match(_this.UNIT.PERCENT)) {
	      ext = _this.UNIT.PERCENT;
	    } else if (!isNaN(value)) {
	      return null;
	    } else {
	      throw new Error('detectUnit can\'t find unit for ' + value);
	    }
	    return ext;
	  };
	  this.rmUnit = function (value, unit) {
	    var valueStr = value.toString();
	    var ext = unit || _this.detectUnit(valueStr);
	    var number = valueStr.replace(ext, '');
	    return parseFloat(number);
	  };
	  this.toPercent = function (value) {
	    var total = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 100;
	    var decimal = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 2;
	    return '' + Math.floor(value / total * 100 * Math.pow(10, decimal)) / Math.pow(10, decimal) + _this.UNIT.PERCENT;
	  };
	}
	;
	exports.default = new UnitUtils();
	module.exports = exports['default'];
	});
	var unitUtils$1 = unwrapExports(unitUtils);

	var process = { argv: [], env: {} }

	var variables = createCommonjsModule(function (module, exports) {
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.assertAscending = assertAscending;
	exports.assertStartAtZero = assertStartAtZero;
	exports.comparable = comparable;
	var _unitUtils2 = _interopRequireDefault(unitUtils);
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	function assertAscending(map, mapName) {
	  var prevKey = void 0;
	  var prevNum = void 0;
	  var asserted = true;
	  Object.keys(map).forEach(function (key) {
	    var num = map[key];
	    if (prevNum == null) {
	    } else if (!comparable(_unitUtils2.default.rmUnit(prevNum), _unitUtils2.default.rmUnit(num))) {
	      if (process.env.NODE !== 'test') {
	        console.warn('Potentially invalid value for ' + mapName + ': This map must be in ascending order, but key \'' + key + '\' has value ' + num + ' whose unit makes it incomparable to ' + prevNum + ', the value of the previous key \'' + prevKey + '\' !');
	      }
	      asserted = false;
	    } else if (_unitUtils2.default.rmUnit(prevNum) >= _unitUtils2.default.rmUnit(num)) {
	      if (process.env.NODE !== 'test') {
	        console.warn('Invalid value for ' + mapName + ': This map must be in ascending order, but key \'' + key + '\' has value ' + num + ' which isn\'t greater than ' + prevNum + ', the value of the previous key \'' + prevKey + '\' !');
	      }
	      asserted = false;
	    }
	    prevKey = key;
	    prevNum = num;
	  });
	  return asserted;
	}
	function assertStartAtZero(map) {
	  var values = Object.keys(map).map(function (key) {
	    return map[key];
	  });
	  var firstValue = _unitUtils2.default.rmUnit(values[0]);
	  var asserted = true;
	  if (firstValue !== 0) {
	    if (process.env.NODE !== 'test') {
	      console.warn('First breakpoint in $grid-breakpoints must start at 0, but starts at ' + firstValue + '.');
	    }
	    asserted = false;
	  }
	  return asserted;
	}
	function comparable(a, b) {
	  return !isNaN(a + b);
	}
	exports.default = {
	  assertAscending: assertAscending,
	  assertStartAtZero: assertStartAtZero,
	  comparable: comparable
	};
	});
	unwrapExports(variables);
	var variables_1 = variables.assertAscending;
	var variables_2 = variables.assertStartAtZero;
	var variables_3 = variables.comparable;

	function allowFalseValue(userValue, defaultValue) {
	  return userValue === false ? userValue : userValue || defaultValue;
	}

	var detectUnit = unitUtils$1.detectUnit,
	    rmUnit = unitUtils$1.rmUnit;
	function makeOriginal() {
	  var userTheme = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
	  var v = {};
	  var u = userTheme;
	  var detectedUnit = void 0;
	  v['$white'] = u['$white'] || '#fff';
	  v['$black'] = u['$black'] || '#000';
	  v['$red'] = u['$red'] || '#d9534f';
	  v['$orange'] = u['$orange'] || '#f0ad4e';
	  v['$yellow'] = u['$yellow'] || '#ffd500';
	  v['$green'] = u['$green'] || '#5cb85c';
	  v['$blue'] = u['$blue'] || '#0275d8';
	  v['$teal'] = u['$teal'] || '#5bc0de';
	  v['$pink'] = u['$pink'] || '#ff5b77';
	  v['$purple'] = u['$purple'] || '#613d7c';
	  v['$gray-dark'] = u['$gray-dark'] || '#292b2c';
	  v['$gray'] = u['$gray'] || '#464a4c';
	  v['$gray-light'] = u['$gray-light'] || '#636c72';
	  v['$gray-lighter'] = u['$gray-lighter'] || '#eceeef';
	  v['$gray-lightest'] = u['$gray-lightest'] || '#f7f7f9';
	  v['$brand-primary'] = u['$brand-primary'] || v['$blue'];
	  v['$brand-success'] = u['$brand-success'] || v['$green'];
	  v['$brand-info'] = u['$brand-info'] || v['$teal'];
	  v['$brand-warning'] = u['$brand-warning'] || v['$orange'];
	  v['$brand-danger'] = u['$brand-danger'] || v['$red'];
	  v['$brand-inverse'] = u['$brand-inverse'] || v['$gray-dark'];
	  v['$enable-rounded'] = allowFalseValue(u['$enable-rounded'], true);
	  v['$enable-shadows'] = allowFalseValue(u['$enable-shadows'], false);
	  v['$enable-gradients'] = allowFalseValue(u['$enable-gradients'], false);
	  v['$enable-transitions'] = allowFalseValue(u['$enable-transitions'], true);
	  v['$enable-hover-media-query'] = allowFalseValue(u['$enable-hover-media-query'], false);
	  v['$enable-grid-classes'] = allowFalseValue(u['$enable-grid-classes'], true);
	  v['$enable-print-styles'] = allowFalseValue(u['$enable-print-styles'], true);
	  v['$spacer'] = u['$spacer'] || '1rem';
	  detectedUnit = detectUnit(v['$spacer']);
	  v['$spacer-halved'] = u['$spacer-halved'] || rmUnit(v['$spacer'], detectedUnit) / 2 + detectedUnit;
	  v['$spacer-x'] = u['$spacer-x'] || v['$spacer'];
	  v['$spacer-y'] = u['$spacer-y'] || v['$spacer'];
	  v['$spacers'] = u['$spacers'] || {
	    0: {
	      x: 0,
	      y: 0
	    },
	    1: {
	      x: rmUnit(v['$spacer-x']) * 0.25 + detectedUnit,
	      y: rmUnit(v['$spacer-y']) * 0.25 + detectedUnit
	    },
	    2: {
	      x: rmUnit(v['$spacer-x']) * 0.5 + detectedUnit,
	      y: rmUnit(v['$spacer-y']) * 0.5 + detectedUnit
	    },
	    3: {
	      x: v['$spacer-x'],
	      y: v['$spacer-y']
	    },
	    4: {
	      x: rmUnit(v['$spacer-x']) * 1.5 + detectedUnit,
	      y: rmUnit(v['$spacer-y']) * 1.5 + detectedUnit
	    },
	    5: {
	      x: rmUnit(v['$spacer-x']) * 3 + detectedUnit,
	      y: rmUnit(v['$spacer-y']) * 3 + detectedUnit
	    }
	  };
	  v['$border-width'] = u['$border-width'] || '1px';
	  v['$sizes'] = u['$sizes'] || {
	    25: '25%',
	    50: '50%',
	    75: '75%',
	    100: '100%'
	  };
	  v['$body-bg'] = u['$body-bg'] || v['$white'];
	  v['$body-color'] = u['$body-color'] || v['$gray-dark'];
	  v['$link-color'] = u['$link-color'] || v['$brand-primary'];
	  v['$link-decoration'] = u['$link-decoration'] || 'none';
	  v['$link-hover-color'] = u['$link-hover-color'] || color(v['$link-color']).darken(0.35).toString();
	  v['$link-hover-decoration'] = u['$link-hover-decoration'] || 'underline';
	  v['$grid-breakpoints'] = u['$grid-breakpoints'] || {
	    xs: '0',
	    sm: '576px',
	    md: '768px',
	    lg: '992px',
	    xl: '1200px',
	    xxl: '1452px'
	  };
	  variables_1(v['$grid-breakpoints'], '$grid-breakpoints');
	  variables_2(v['$grid-breakpoints']);
	  v['$container-max-widths'] = u['$container-max-widths'] || {
	    sm: '540px',
	    md: '720px',
	    lg: '960px',
	    xl: '1140px'
	  };
	  variables_1(v['$container-max-widths'], '$container-max-widths');
	  v['$grid-columns'] = u['$grid-columns'] || '12';
	  v['$grid-gutter-width-base'] = u['$grid-gutter-width-base'] || '30px';
	  v['$grid-gutter-widths'] = u['$grid-gutter-widths'] || {
	    xs: v['$grid-gutter-width-base'],
	    sm: v['$grid-gutter-width-base'],
	    md: v['$grid-gutter-width-base'],
	    lg: v['$grid-gutter-width-base'],
	    xl: v['$grid-gutter-width-base']
	  };
	  v['$font-family-sans-serif'] = u['$font-family-sans-serif'] || '-apple-system, system-ui, BlinkMacSystemFont, "Segoe UI", Roboto, "Helvetica Neue", Arial, sans-serif';
	  v['$font-family-monospace'] = u['$font-family-monospace'] || 'Menlo, Monaco, Consolas, "Liberation Mono", "Courier New", monospace';
	  v['$font-family-base'] = u['$font-family-base'] || v['$font-family-sans-serif'];
	  v['$font-size-base'] = u['$font-size-base'] || '1rem';
	  v['$font-size-lg'] = u['$font-size-lg'] || '1.25rem';
	  v['$font-size-sm'] = u['$font-size-sm'] || '.875rem';
	  v['$font-size-xs'] = u['$font-size-xs'] || '.75rem';
	  v['$font-weight-normal'] = u['$font-weight-normal'] || 'normal';
	  v['$font-weight-bold'] = u['$font-weight-bold'] || 'bold';
	  v['$font-weight-base'] = u['$font-weight-base'] || v['$font-weight-normal'];
	  v['$line-height-base'] = u['$line-height-base'] || '1.5';
	  v['$font-size-h1'] = u['$font-size-h1'] || '2.5rem';
	  v['$font-size-h2'] = u['$font-size-h2'] || '2rem';
	  v['$font-size-h3'] = u['$font-size-h3'] || '1.75rem';
	  v['$font-size-h4'] = u['$font-size-h4'] || '1.5rem';
	  v['$font-size-h5'] = u['$font-size-h5'] || '1.25rem';
	  v['$font-size-h6'] = u['$font-size-h6'] || '1rem';
	  detectedUnit = detectUnit(v['$spacer']);
	  v['$headings-margin-bottom'] = u['$headings-margin-bottom'] || rmUnit(v['$spacer'], detectedUnit) / 2 + detectedUnit;
	  v['$headings-font-family'] = u['$headings-font-family'] || 'inherit';
	  v['$headings-font-weight'] = u['$headings-font-weight'] || '500';
	  v['$headings-line-height'] = u['$headings-line-height'] || '1.1';
	  v['$headings-color'] = u['$headings-color'] || 'inherit';
	  v['$display1-size'] = u['$display1-size'] || '6rem';
	  v['$display2-size'] = u['$display2-size'] || '5.5rem';
	  v['$display3-size'] = u['$display3-size'] || '4.5rem';
	  v['$display4-size'] = u['$display4-size'] || '3.5rem';
	  v['$display1-weight'] = u['$display1-weight'] || '300';
	  v['$display2-weight'] = u['$display2-weight'] || '300';
	  v['$display3-weight'] = u['$display3-weight'] || '300';
	  v['$display4-weight'] = u['$display4-weight'] || '300';
	  v['$display-line-height'] = u['$display-line-height'] || v['$headings-line-height'];
	  v['$lead-font-size'] = u['$lead-font-size'] || '1.25rem';
	  v['$lead-font-weight'] = u['$lead-font-weight'] || '300';
	  v['$small-font-size'] = u['$small-font-size'] || '80%';
	  v['$text-muted'] = u['$text-muted'] || v['$gray-light'];
	  v['$blockquote-small-color'] = u['$blockquote-small-color'] || v['$gray-light'];
	  detectedUnit = detectUnit(v['$font-size-base']);
	  v['$blockquote-font-size'] = u['$blockquote-font-size'] || rmUnit(v['$font-size-base'], detectedUnit) * 1.25 + detectedUnit;
	  v['$blockquote-border-color'] = u['$blockquote-border-color'] || v['$gray-lighter'];
	  v['$blockquote-border-width'] = u['$blockquote-border-width'] || '.25rem';
	  v['$hr-border-color'] = u['$hr-border-color'] || color(v['$black']).alpha(0.1).toString();
	  v['$hr-border-width'] = u['$hr-border-width'] || v['$border-width'];
	  v['$mark-padding'] = u['$mark-padding'] || '.2em';
	  v['$dt-font-weight'] = u['$dt-font-weight'] || v['$font-weight-bold'];
	  v['$kbd-box-shadow'] = u['$kbd-box-shadow'] || 'inset 0 -.1rem 0 ' + color(v['$black']).alpha(0.25).toString();
	  v['$nested-kbd-font-weight'] = u['$nested-kbd-font-weight'] || v['$font-weight-bold'];
	  v['$list-inline-padding'] = u['$list-inline-padding'] || '5px';
	  v['$line-height-lg'] = u['$line-height-lg'] || '1.6';
	  v['$line-height-sm'] = u['$line-height-sm'] || '1.3';
	  v['$border-radius'] = u['$border-radius'] || '.25rem';
	  v['$border-radius-lg'] = u['$border-radius-lg'] || '.3rem';
	  v['$border-radius-sm'] = u['$border-radius-sm'] || '.2rem';
	  v['$component-active-color'] = u['$component-active-color'] || v['$white'];
	  v['$component-active-bg'] = u['$component-active-bg'] || v['$brand-primary'];
	  v['$caret-width'] = u['$caret-width'] || '.3em';
	  v['$transition-base'] = u['$transition-base'] || 'all .2s ease-in-out';
	  v['$transition-fade'] = u['$transition-fade'] || 'opacity .15s linear';
	  v['$transition-collapse'] = u['$transition-collapse'] || 'height .35s ease';
	  v['$table-cell-padding'] = u['$table-cell-padding'] || '.75rem';
	  v['$table-sm-cell-padding'] = u['$table-sm-cell-padding'] || '.3rem';
	  v['$table-bg'] = u['$table-bg'] || 'transparent';
	  v['$table-inverse-bg'] = u['$table-inverse-bg'] || v['$gray-dark'];
	  v['$table-inverse-bg-accent'] = u['$table-inverse-bg-accent'] || color(v['$white']).alpha(0.05).toString();
	  v['$table-inverse-bg-hover'] = u['$table-inverse-bg-hover'] || color(v['$white']).alpha(0.075).toString();
	  v['$table-inverse-color'] = u['$table-inverse-color'] || v['$body-bg'];
	  v['$table-inverse-border'] = u['$table-inverse-border'] || color(v['$gray-dark']).lighten(0.075).toString();
	  v['$table-bg-accent'] = u['$table-bg-accent'] || color(v['$black']).alpha(0.05).toString();
	  v['$table-bg-hover'] = u['$table-bg-hover'] || color(v['$black']).alpha(0.075).toString();
	  v['$table-bg-active'] = u['$table-bg-active'] || v['$table-bg-hover'];
	  v['$table-head-bg'] = u['$table-head-bg'] || v['$gray-lighter'];
	  v['$table-head-color'] = u['$table-head-color'] || v['$gray'];
	  v['$table-border-width'] = u['$table-border-width'] || v['$border-width'];
	  v['$table-border-color'] = u['$table-border-color'] || v['$gray-lighter'];
	  v['$btn-padding-x'] = u['$btn-padding-x'] || '1rem';
	  v['$btn-padding-y'] = u['$btn-padding-y'] || '.5rem';
	  v['$btn-line-height'] = u['$btn-line-height'] || '1.25';
	  v['$btn-font-weight'] = u['$btn-font-weight'] || v['$font-weight-normal'];
	  v['$btn-box-shadow'] = u['$btn-box-shadow'] || 'inset 0 1px 0 ' + color(v['$white']).alpha(0.15).toString() + ', 0 1px 1px ' + color(v['$black']).alpha(0.075).toString();
	  v['$btn-focus-box-shadow'] = u['$btn-focus-box-shadow'] || '0 0 0 2px ' + color(v['$brand-primary']).alpha(0.25).toString();
	  v['$btn-active-box-shadow'] = u['$btn-active-box-shadow'] || 'inset 0 3px 5px ' + color(v['$black']).alpha(0.125).toString();
	  v['$btn-primary-color'] = u['$btn-primary-color'] || v['$white'];
	  v['$btn-primary-bg'] = u['$btn-primary-bg'] || v['$brand-primary'];
	  v['$btn-primary-border'] = u['$btn-primary-border'] || v['$btn-primary-bg'];
	  v['$btn-secondary-color'] = u['$btn-secondary-color'] || v['$gray-dark'];
	  v['$btn-secondary-bg'] = u['$btn-secondary-bg'] || v['$white'];
	  v['$btn-secondary-border'] = u['$btn-secondary-border'] || '#ccc';
	  v['$btn-info-color'] = u['$btn-info-color'] || v['$white'];
	  v['$btn-info-bg'] = u['$btn-info-bg'] || v['$brand-info'];
	  v['$btn-info-border'] = u['$btn-info-border'] || v['$btn-info-bg'];
	  v['$btn-success-color'] = u['$btn-success-color'] || v['$white'];
	  v['$btn-success-bg'] = u['$btn-success-bg'] || v['$brand-success'];
	  v['$btn-success-border'] = u['$btn-success-border'] || v['$btn-success-bg'];
	  v['$btn-warning-color'] = u['$btn-warning-color'] || v['$white'];
	  v['$btn-warning-bg'] = u['$btn-warning-bg'] || v['$brand-warning'];
	  v['$btn-warning-border'] = u['$btn-warning-border'] || v['$btn-warning-bg'];
	  v['$btn-danger-color'] = u['$btn-danger-color'] || v['$white'];
	  v['$btn-danger-bg'] = u['$btn-danger-bg'] || v['$brand-danger'];
	  v['$btn-danger-border'] = u['$btn-danger-border'] || v['$btn-danger-bg'];
	  v['$btn-link-disabled-color'] = u['$btn-link-disabled-color'] || v['$gray-light'];
	  v['$btn-padding-x-sm'] = u['$btn-padding-x-sm'] || '.5rem';
	  v['$btn-padding-y-sm'] = u['$btn-padding-y-sm'] || '.25rem';
	  v['$btn-padding-x-lg'] = u['$btn-padding-x-lg'] || '1.5rem';
	  v['$btn-padding-y-lg'] = u['$btn-padding-y-lg'] || '.75rem';
	  v['$btn-block-spacing-y'] = u['$btn-block-spacing-y'] || '.5rem';
	  v['$btn-border-radius'] = u['$btn-border-radius'] || v['$border-radius'];
	  v['$btn-border-radius-lg'] = u['$btn-border-radius-lg'] || v['$border-radius-lg'];
	  v['$btn-border-radius-sm'] = u['$btn-border-radius-sm'] || v['$border-radius-sm'];
	  v['$btn-transition'] = u['$btn-transition'] || 'all .2s ease-in-out';
	  v['$input-padding-x'] = u['$input-padding-x'] || '.75rem';
	  v['$input-padding-y'] = u['$input-padding-y'] || '.5rem';
	  v['$input-line-height'] = u['$input-line-height'] || '1.25';
	  v['$input-bg'] = u['$input-bg'] || v['$white'];
	  v['$input-bg-disabled'] = u['$input-bg-disabled'] || v['$gray-lighter'];
	  v['$input-color'] = u['$input-color'] || v['$gray'];
	  v['$input-border-color'] = u['$input-border-color'] || color(v['$black']).alpha(0.15).toString();
	  v['$input-btn-border-width'] = u['$input-btn-border-width'] || v['$border-width'];
	  v['$input-box-shadow'] = u['$input-box-shadow'] || 'inset 0 1px 1px ' + color(v['$black']).alpha(0.075).toString();
	  v['$input-border-radius'] = u['$input-border-radius'] || v['$border-radius'];
	  v['$input-border-radius-lg'] = u['$input-border-radius-lg'] || v['$border-radius-lg'];
	  v['$input-border-radius-sm'] = u['$input-border-radius-sm'] || v['$border-radius-sm'];
	  v['$input-bg-focus'] = u['$input-bg-focus'] || v['$input-bg'];
	  v['$input-border-focus'] = u['$input-border-focus'] || color(v['$brand-primary']).lighten(0.25).toString();
	  v['$input-box-shadow-focus'] = u['$input-box-shadow-focus'] || v['$input-box-shadow'] + ', 0 0 8px rgba(' + v['$input-border-focus'] + ',.6)';
	  v['$input-color-focus'] = u['$input-color-focus'] || v['$input-color'];
	  v['$input-color-placeholder'] = u['$input-color-placeholder'] || v['$gray-light'];
	  v['$input-padding-x-sm'] = u['$input-padding-x-sm'] || '.5rem';
	  v['$input-padding-y-sm'] = u['$input-padding-y-sm'] || '.25rem';
	  v['$input-padding-x-lg'] = u['$input-padding-x-lg'] || '1.5rem';
	  v['$input-padding-y-lg'] = u['$input-padding-y-lg'] || '.75rem';
	  detectedUnit = detectUnit(v['$font-size-base']);
	  v['$input-height'] = u['$input-height'] || rmUnit(v['$font-size-base'], detectedUnit) * v['$line-height-base'] + rmUnit(v['$input-padding-y'], detectedUnit) * 2 + detectedUnit;
	  v['$input-height-sm'] = u['$input-height-sm'] || rmUnit(v['$font-size-sm'], detectedUnit) * v['$line-height-sm'] + rmUnit(v['$input-padding-y-sm'], detectedUnit) * 2 + detectedUnit;
	  v['$input-height-lg'] = u['$input-height-lg'] || rmUnit(v['$font-size-lg'], detectedUnit) * v['$line-height-lg'] + rmUnit(v['$input-padding-y-lg'], detectedUnit) * 2 + detectedUnit;
	  v['$input-transition'] = u['$input-transition'] || 'border-color ease-in-out .15s, box-shadow ease-in-out .15s';
	  v['$form-text-margin-top'] = u['$form-text-margin-top'] || '.25rem';
	  v['$form-feedback-margin-top'] = u['$form-feedback-margin-top'] || v['$form-text-margin-top'];
	  v['$form-check-margin-bottom'] = u['$form-check-margin-bottom'] || '.5rem';
	  v['$form-check-input-gutter'] = u['$form-check-input-gutter'] || '1.25rem';
	  v['$form-check-input-margin-y'] = u['$form-check-input-margin-y'] || '.25rem';
	  v['$form-check-input-margin-x'] = u['$form-check-input-margin-x'] || '.25rem';
	  v['$form-check-inline-margin-x'] = u['$form-check-inline-margin-x'] || '.75rem';
	  v['$form-group-margin-bottom'] = u['$form-group-margin-bottom'] || v['$spacer-y'];
	  v['$input-group-addon-bg'] = u['$input-group-addon-bg'] || v['$gray-lighter'];
	  v['$input-group-addon-border-color'] = u['$input-group-addon-border-color'] || v['$input-border-color'];
	  v['$cursor-disabled'] = u['$cursor-disabled'] || 'not-allowed';
	  v['$custom-control-gutter'] = u['$custom-control-gutter'] || '1.5rem';
	  v['$custom-control-spacer-x'] = u['$custom-control-spacer-x'] || '1rem';
	  v['$custom-control-spacer-y'] = u['$custom-control-spacer-y'] || '.25rem';
	  v['$custom-control-indicator-size'] = u['$custom-control-indicator-size'] || '1rem';
	  v['$custom-control-indicator-bg'] = u['$custom-control-indicator-bg'] || '#ddd';
	  v['$custom-control-indicator-bg-size'] = u['$custom-control-indicator-bg-size'] || '50% 50%';
	  v['$custom-control-indicator-box-shadow'] = u['$custom-control-indicator-box-shadow'] || 'inset 0 .25rem .25rem ' + color(v['$black']).alpha(0.1).toString();
	  v['$custom-control-disabled-cursor'] = u['$custom-control-disabled-cursor'] || v['$cursor-disabled'];
	  v['$custom-control-disabled-indicator-bg'] = u['$custom-control-disabled-indicator-bg'] || v['$gray-lighter'];
	  v['$custom-control-disabled-description-color'] = u['$custom-control-disabled-description-color'] || v['$gray-light'];
	  v['$custom-control-checked-indicator-color'] = u['$custom-control-checked-indicator-color'] || v['$white'];
	  v['$custom-control-checked-indicator-bg'] = u['$custom-control-checked-indicator-bg'] || v['$brand-primary'];
	  v['$custom-control-checked-indicator-box-shadow'] = u['$custom-control-checked-indicator-box-shadow'] || 'none';
	  v['$custom-control-focus-indicator-box-shadow'] = u['$custom-control-focus-indicator-box-shadow'] || '0 0 0 1px ' + v['$body-bg'] + ', 0 0 0 3px ' + v['$brand-primary'];
	  v['$custom-control-active-indicator-color'] = u['$custom-control-active-indicator-color'] || v['$white'];
	  v['$custom-control-active-indicator-bg'] = u['$custom-control-active-indicator-bg'] || color(v['$brand-primary']).lighten(0.35).toString();
	  v['$custom-control-active-indicator-box-shadow'] = u['$custom-control-active-indicator-box-shadow'] || 'none';
	  v['$custom-checkbox-radius'] = u['$custom-checkbox-radius'] || v['$border-radius'];
	  v['$custom-checkbox-checked-icon'] = u['$custom-checkbox-checked-icon'] || 'url(\'data:image/svg+xml;charset=utf8,%3Csvg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 8 8"%3E%3Cpath fill="' + v['$custom-control-checked-indicator-color'] + '" d="M6.564.75l-3.59 3.612-1.538-1.55L0 4.26 2.974 7.25 8 2.193z"/%3E%3C/svg%3E\')';
	  v['$custom-checkbox-indeterminate-bg'] = u['$custom-checkbox-indeterminate-bg'] || v['$brand-primary'];
	  v['$custom-checkbox-indeterminate-indicator-color'] = u['$custom-checkbox-indeterminate-indicator-color'] || v['$custom-control-checked-indicator-color'];
	  v['$custom-checkbox-indeterminate-icon'] = u['$custom-checkbox-indeterminate-icon'] || 'url(\'data:image/svg+xml;charset=utf8,%3Csvg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 4 4"%3E%3Cpath stroke="' + v['$custom-checkbox-indeterminate-indicator-color'] + '" d="M0 2h4"/%3E%3C/svg%3E\')';
	  v['$custom-checkbox-indeterminate-box-shadow'] = u['$custom-checkbox-indeterminate-box-shadow'] || 'none';
	  v['$custom-radio-radius'] = u['$custom-radio-radius'] || '50%';
	  v['$custom-radio-checked-icon'] = u['$custom-radio-checked-icon'] || 'url(\'data:image/svg+xml;charset=utf8,%3Csvg xmlns="http://www.w3.org/2000/svg" viewBox="-4 -4 8 8"%3E%3Ccircle r="3" fill="' + v['$custom-control-checked-indicator-color'] + '"/%3E%3C/svg%3E\')';
	  v['$custom-select-padding-x'] = u['$custom-select-padding-x'] || '.75rem ';
	  v['$custom-select-padding-y'] = u['$custom-select-padding-y'] || '.375rem';
	  v['$custom-select-indicator-padding'] = u['$custom-select-indicator-padding'] || '1rem';
	  v['$custom-select-line-height'] = u['$custom-select-line-height'] || v['$input-line-height'];
	  v['$custom-select-color'] = u['$custom-select-color'] || v['$input-color'];
	  v['$custom-select-disabled-color'] = u['$custom-select-disabled-color'] || v['$gray-light'];
	  v['$custom-select-bg'] = u['$custom-select-bg'] || v['$white'];
	  v['$custom-select-disabled-bg'] = u['$custom-select-disabled-bg'] || v['$gray-lighter'];
	  v['$custom-select-bg-size'] = u['$custom-select-bg-size'] || '8px 10px';
	  v['$custom-select-indicator-color'] = u['$custom-select-indicator-color'] || '#333';
	  v['$custom-select-indicator'] = u['$custom-select-indicator'] || 'url(\'data:image/svg+xml;charset=utf8,%3Csvg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 4 5"%3E%3Cpath fill="' + v['$custom-select-indicator-color'] + '" d="M2 0L0 2h4zm0 5L0 3h4z"/%3E%3C/svg%3E\')';
	  v['$custom-select-border-width'] = u['$custom-select-border-width'] || v['$input-btn-border-width'];
	  v['$custom-select-border-color'] = u['$custom-select-border-color'] || v['$input-border-color'];
	  v['$custom-select-border-radius'] = u['$custom-select-border-radius'] || v['$border-radius'];
	  v['$custom-select-focus-border-color'] = u['$custom-select-focus-border-color'] || color(v['$brand-primary']).lighten(0.25).toString();
	  v['$custom-select-focus-box-shadow'] = u['$custom-select-focus-box-shadow'] || 'inset 0 1px 2px ' + color(v['$black']).alpha(0.75).toString() + ', 0 0 5px rgba(' + v['$custom-select-focus-border-color'] + ', .5)';
	  v['$custom-select-sm-font-size'] = u['$custom-select-sm-font-size'] || '75%';
	  v['$custom-file-height'] = u['$custom-file-height'] || '2.5rem';
	  v['$custom-file-width'] = u['$custom-file-width'] || '14rem';
	  v['$custom-file-focus-box-shadow'] = u['$custom-file-focus-box-shadow'] || '0 0 0 .075rem ' + v['$white'] + ', 0 0 0 .2rem ' + v['$brand-primary'];
	  v['$custom-file-padding-x'] = u['$custom-file-padding-x'] || '.5rem';
	  v['$custom-file-padding-y'] = u['$custom-file-padding-y'] || '1rem';
	  v['$custom-file-line-height'] = u['$custom-file-line-height'] || '1.5';
	  v['$custom-file-color'] = u['$custom-file-color'] || v['$gray'];
	  v['$custom-file-bg'] = u['$custom-file-bg'] || v['$white'];
	  v['$custom-file-border-width'] = u['$custom-file-border-width'] || v['$border-width'];
	  v['$custom-file-border-color'] = u['$custom-file-border-color'] || v['$input-border-color'];
	  v['$custom-file-border-radius'] = u['$custom-file-border-radius'] || v['$border-radius'];
	  v['$custom-file-box-shadow'] = u['$custom-file-box-shadow'] || 'inset 0 .2rem .4rem ' + color(v['$black']).alpha(0.05).toString();
	  v['$custom-file-button-color'] = u['$custom-file-button-color'] || v['$custom-file-color'];
	  v['$custom-file-button-bg'] = u['$custom-file-button-bg'] || v['$gray-lighter'];
	  v['$custom-file-text'] = u['$custom-file-text'] || {
	    placeholder: {
	      en: 'Choose file...'
	    },
	    'button-label': {
	      en: 'Browse'
	    }
	  };
	  v['$form-icon-success-color'] = u['$form-icon-success-color'] || v['$brand-success'];
	  v['$form-icon-success'] = u['$form-icon-success'] || 'url(\'data:image/svg+xml;charset=utf8,%3Csvg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 8 8"%3E%3Cpath fill="' + v['$form-icon-success-color'] + '" d="M2.3 6.73L.6 4.53c-.4-1.04.46-1.4 1.1-.8l1.1 1.4 3.4-3.8c.6-.63 1.6-.27 1.2.7l-4 4.6c-.43.5-.8.4-1.1.1z"/%3E%3C/svg%3E\')';
	  v['$form-icon-warning-color'] = u['$form-icon-warning-color'] || v['$brand-warning'];
	  v['$form-icon-warning'] = u['$form-icon-warning'] || 'url(\'data:image/svg+xml;charset=utf8,%3Csvg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 8 8"%3E%3Cpath fill="' + v['$form-icon-warning-color'] + '" d="M4.4 5.324h-.8v-2.46h.8zm0 1.42h-.8V5.89h.8zM3.76.63L.04 7.075c-.115.2.016.425.26.426h7.397c.242 0 .372-.226.258-.426C6.726 4.924 5.47 2.79 4.253.63c-.113-.174-.39-.174-.494 0z"/%3E%3C/svg%3E\')';
	  v['$form-icon-danger-color'] = u['$form-icon-danger-color'] || v['$brand-danger'];
	  v['$form-icon-danger'] = u['$form-icon-danger'] || 'url(\'data:image/svg+xml;charset=utf8,%3Csvg xmlns="http://www.w3.org/2000/svg" fill="' + v['$form-icon-danger-color'] + '" viewBox="-2 -2 7 7"%3E%3Cpath stroke="%23d9534f" d="M0 0l3 3m0-3L0 3"/%3E%3Ccircle r=".5"/%3E%3Ccircle cx="3" r=".5"/%3E%3Ccircle cy="3" r=".5"/%3E%3Ccircle cx="3" cy="3" r=".5"/%3E%3C/svg%3E\')';
	  v['$dropdown-min-width'] = u['$dropdown-min-width'] || '10rem';
	  v['$dropdown-padding-y'] = u['$dropdown-padding-y'] || '.5rem';
	  v['$dropdown-margin-top'] = u['$dropdown-margin-top'] || '.125rem';
	  v['$dropdown-bg'] = u['$dropdown-bg'] || v['$white'];
	  v['$dropdown-border-color'] = u['$dropdown-border-color'] || color(v['$black']).alpha(0.15).toString();
	  v['$dropdown-border-width'] = u['$dropdown-border-width'] || v['$border-width'];
	  v['$dropdown-divider-bg'] = u['$dropdown-divider-bg'] || v['$gray-lighter'];
	  v['$dropdown-box-shadow'] = u['$dropdown-box-shadow'] || '0 .5rem 1rem rgba(' + v['$black'] + ',.175)';
	  v['$dropdown-link-color'] = u['$dropdown-link-color'] || v['$gray-dark'];
	  v['$dropdown-link-hover-color'] = u['$dropdown-link-hover-color'] || color(v['$gray-dark']).darken(0.05).toString();
	  v['$dropdown-link-hover-bg'] = u['$dropdown-link-hover-bg'] || v['$gray-lightest'];
	  v['$dropdown-link-active-color'] = u['$dropdown-link-active-color'] || v['$component-active-color'];
	  v['$dropdown-link-active-bg'] = u['$dropdown-link-active-bg'] || v['$component-active-bg'];
	  v['$dropdown-link-disabled-color'] = u['$dropdown-link-disabled-color'] || v['$gray-light'];
	  v['$dropdown-item-padding-x'] = u['$dropdown-item-padding-x'] || '1.5rem';
	  v['$dropdown-header-color'] = u['$dropdown-header-color'] || v['$gray-light'];
	  v['$zindex-dropdown-backdrop'] = u['$zindex-dropdown-backdrop'] || '990';
	  v['$zindex-dropdown'] = u['$zindex-dropdown'] || '1000';
	  v['$zindex-fixed'] = u['$zindex-fixed'] || '1030';
	  v['$zindex-sticky'] = u['$zindex-sticky'] || '1030';
	  v['$zindex-modal-backdrop'] = u['$zindex-modal-backdrop'] || '2040';
	  v['$zindex-modal'] = u['$zindex-modal'] || '2050';
	  v['$zindex-popover'] = u['$zindex-popover'] || '1060';
	  v['$zindex-tooltip'] = u['$zindex-tooltip'] || '1070';
	  v['$navbar-padding-x'] = u['$navbar-padding-x'] || v['$spacer'];
	  v['$navbar-padding-y'] = u['$navbar-padding-y'] || v['$spacer-halved'];
	  v['$navbar-toggler-padding-x'] = u['$navbar-toggler-padding-x'] || '.75rem';
	  v['$navbar-toggler-padding-y'] = u['$navbar-toggler-padding-y'] || '.25rem';
	  v['$navbar-toggler-font-size'] = u['$navbar-toggler-font-size'] || v['$font-size-lg'];
	  v['$navbar-toggler-border-radius'] = u['$navbar-toggler-border-radius'] || v['$btn-border-radius'];
	  v['$navbar-inverse-color'] = u['$navbar-inverse-color'] || color(v['$white']).alpha(0.5).toString();
	  v['$navbar-inverse-hover-color'] = u['$navbar-inverse-hover-color'] || color(v['$white']).alpha(0.75).toString();
	  v['$navbar-inverse-active-color'] = u['$navbar-inverse-active-color'] || color(v['$white']).alpha(1).toString();
	  v['$navbar-inverse-disabled-color'] = u['$navbar-inverse-disabled-color'] || color(v['$white']).alpha(0.25).toString();
	  v['$navbar-inverse-toggler-bg'] = u['$navbar-inverse-toggler-bg'] || 'url(\'data:image/svg+xml;charset=utf8,%3Csvg viewBox="0 0 30 30" xmlns="http://www.w3.org/2000/svg"%3E%3Cpath stroke="' + v['$navbar-inverse-color'] + '" stroke-width="2" stroke-linecap="round" stroke-miterlimit="10" d="M4 7h22M4 15h22M4 23h22"/%3E%3C/svg%3E\')';
	  v['$navbar-inverse-toggler-border'] = u['$navbar-inverse-toggler-border'] || color(v['$white']).alpha(0.1).toString();
	  v['$navbar-light-color'] = u['$navbar-light-color'] || color(v['$black']).alpha(0.5).toString();
	  v['$navbar-light-hover-color'] = u['$navbar-light-hover-color'] || color(v['$black']).alpha(0.7).toString();
	  v['$navbar-light-active-color'] = u['$navbar-light-active-color'] || color(v['$black']).alpha(0.9).toString();
	  v['$navbar-light-disabled-color'] = u['$navbar-light-disabled-color'] || color(v['$black']).alpha(0.3).toString();
	  v['$navbar-light-toggler-bg'] = u['$navbar-light-toggler-bg'] || 'url(\'data:image/svg+xml;charset=utf8,%3Csvg viewBox="0 0 30 30" xmlns="http://www.w3.org/2000/svg"%3E%3Cpath stroke="' + v['$navbar-light-color'] + '" stroke-width="2" stroke-linecap="round" stroke-miterlimit="10" d="M4 7h22M4 15h22M4 23h22"/%3E%3C/svg%3E\')';
	  v['$navbar-light-toggler-border'] = u['$navbar-light-toggler-border'] || color(v['$black']).alpha(0.1).toString();
	  v['$nav-link-padding'] = u['$nav-link-padding'] || '.5em 1em';
	  v['$nav-disabled-link-color'] = u['$nav-disabled-link-color'] || v['$gray-light'];
	  v['$nav-tabs-border-color'] = u['$nav-tabs-border-color'] || '#ddd';
	  v['$nav-tabs-border-width'] = u['$nav-tabs-border-width'] || v['$border-width'];
	  v['$nav-tabs-border-radius'] = u['$nav-tabs-border-radius'] || v['$border-radius'];
	  v['$nav-tabs-link-hover-border-color'] = u['$nav-tabs-link-hover-border-color'] || v['$gray-lighter'];
	  v['$nav-tabs-active-link-hover-color'] = u['$nav-tabs-active-link-hover-color'] || v['$gray'];
	  v['$nav-tabs-active-link-hover-bg'] = u['$nav-tabs-active-link-hover-bg'] || v['$body-bg'];
	  v['$nav-tabs-active-link-hover-border-color'] = u['$nav-tabs-active-link-hover-border-color'] || '#ddd';
	  v['$nav-pills-border-radius'] = u['$nav-pills-border-radius'] || v['$border-radius'];
	  v['$nav-pills-active-link-color'] = u['$nav-pills-active-link-color'] || v['$component-active-color'];
	  v['$nav-pills-active-link-bg'] = u['$nav-pills-active-link-bg'] || v['$component-active-bg'];
	  v['$pagination-padding-x'] = u['$pagination-padding-x'] || '.75rem';
	  v['$pagination-padding-y'] = u['$pagination-padding-y'] || '.5rem';
	  v['$pagination-padding-x-sm'] = u['$pagination-padding-x-sm'] || '.5rem';
	  v['$pagination-padding-y-sm'] = u['$pagination-padding-y-sm'] || '.25rem';
	  v['$pagination-padding-x-lg'] = u['$pagination-padding-x-lg'] || '1.5rem';
	  v['$pagination-padding-y-lg'] = u['$pagination-padding-y-lg'] || '.75rem';
	  v['$pagination-line-height'] = u['$pagination-line-height'] || '1.25';
	  v['$pagination-color'] = u['$pagination-color'] || v['$link-color'];
	  v['$pagination-bg'] = u['$pagination-bg'] || v['$white'];
	  v['$pagination-border-width'] = u['$pagination-border-width'] || v['$border-width'];
	  v['$pagination-border-color'] = u['$pagination-border-color'] || '#ddd';
	  v['$pagination-hover-color'] = u['$pagination-hover-color'] || v['$link-hover-color'];
	  v['$pagination-hover-bg'] = u['$pagination-hover-bg'] || v['$gray-lighter'];
	  v['$pagination-hover-border'] = u['$pagination-hover-border'] || '#ddd';
	  v['$pagination-active-color'] = u['$pagination-active-color'] || v['$white'];
	  v['$pagination-active-bg'] = u['$pagination-active-bg'] || v['$brand-primary'];
	  v['$pagination-active-border'] = u['$pagination-active-border'] || v['$brand-primary'];
	  v['$pagination-disabled-color'] = u['$pagination-disabled-color'] || v['$gray-light'];
	  v['$pagination-disabled-bg'] = u['$pagination-disabled-bg'] || v['$white'];
	  v['$pagination-disabled-border'] = u['$pagination-disabled-border'] || '#ddd';
	  v['$jumbotron-padding'] = u['$jumbotron-padding'] || '2rem';
	  v['$jumbotron-bg'] = u['$jumbotron-bg'] || v['$gray-lighter'];
	  v['$state-success-text'] = u['$state-success-text'] || '#3c763d';
	  v['$state-success-bg'] = u['$state-success-bg'] || '#dff0d8';
	  v['$state-success-border'] = u['$state-success-border'] || color(v['$state-success-bg']).darken(0.05).toString();
	  v['$state-info-text'] = u['$state-info-text'] || '#31708f';
	  v['$state-info-bg'] = u['$state-info-bg'] || '#d9edf7';
	  v['$state-info-border'] = u['$state-info-border'] || color(v['$state-info-bg']).darken(0.07).toString();
	  v['$state-warning-text'] = u['$state-warning-text'] || '#8a6d3b';
	  v['$state-warning-bg'] = u['$state-warning-bg'] || '#fcf8e3';
	  v['$mark-bg'] = u['$mark-bg'] || v['$state-warning-bg'];
	  v['$state-warning-border'] = u['$state-warning-border'] || color(v['$state-warning-bg']).darken(0.05).toString();
	  v['$state-danger-text'] = u['$state-danger-text'] || '#a94442';
	  v['$state-danger-bg'] = u['$state-danger-bg'] || '#f2dede';
	  v['$state-danger-border'] = u['$state-danger-border'] || color(v['$state-danger-bg']).darken(0.05).toString();
	  v['$card-spacer-x'] = u['$card-spacer-x'] || '1.25rem';
	  v['$card-spacer-y'] = u['$card-spacer-y'] || '.75rem';
	  v['$card-border-width'] = u['$card-border-width'] || '1px';
	  v['$card-border-radius'] = u['$card-border-radius'] || v['$border-radius'];
	  v['$card-border-color'] = u['$card-border-color'] || color(v['$black']).alpha(0.125).toString();
	  v['$card-border-radius-inner'] = u['$card-border-radius-inner'] || 'calc(' + v['$card-border-radius'] + ' - ' + v['$card-border-width'] + ')';
	  v['$card-cap-bg'] = u['$card-cap-bg'] || v['$gray-lightest'];
	  v['$card-bg'] = u['$card-bg'] || v['$white'];
	  v['$card-link-hover-color'] = u['$card-link-hover-color'] || v['$white'];
	  v['$card-img-overlay-padding'] = u['$card-img-overlay-padding'] || '1.25rem';
	  detectedUnit = detectUnit(v['$grid-gutter-width-base']);
	  v['$card-deck-margin'] = u['$card-deck-margin'] || rmUnit(v['$grid-gutter-width-base'], detectedUnit) / 2 + detectedUnit;
	  v['$card-columns-count-md'] = u['$card-columns-count-md'] || '2';
	  v['$card-columns-gap-md'] = u['$card-columns-gap-md'] || '1rem';
	  v['$card-columns-margin-md'] = u['$card-columns-margin-md'] || v['$card-spacer-y'];
	  v['$card-columns-count-lg'] = u['$card-columns-count-lg'] || '2';
	  v['$card-columns-gap-lg'] = u['$card-columns-gap-lg'] || '1.15rem';
	  v['$card-columns-margin-lg'] = u['$card-columns-margin-lg'] || v['$card-spacer-y'];
	  v['$card-columns-count-xl'] = u['$card-columns-count-xl'] || '3';
	  v['$card-columns-gap-xl'] = u['$card-columns-gap-xl'] || '1.25rem';
	  v['$card-columns-margin-xl'] = u['$card-columns-margin-xl'] || v['$card-spacer-y'];
	  v['$card-columns-count-xxl'] = u['$card-columns-count-xxl'] || '4';
	  v['$card-columns-gap-xxl'] = u['$card-columns-gap-xxl'] || '1.25rem';
	  v['$card-columns-margin-xxl'] = u['$card-columns-margin-xxl'] || v['$card-spacer-y'];
	  v['$tooltip-max-width'] = u['$tooltip-max-width'] || '200px';
	  v['$tooltip-color'] = u['$tooltip-color'] || v['$white'];
	  v['$tooltip-bg'] = u['$tooltip-bg'] || v['$black'];
	  v['$tooltip-opacity'] = u['$tooltip-opacity'] || '.9';
	  v['$tooltip-padding-y'] = u['$tooltip-padding-y'] || '3px';
	  v['$tooltip-padding-x'] = u['$tooltip-padding-x'] || '8px';
	  v['$tooltip-margin'] = u['$tooltip-margin'] || '3px';
	  v['$tooltip-arrow-width'] = u['$tooltip-arrow-width'] || '5px';
	  v['$tooltip-arrow-color'] = u['$tooltip-arrow-color'] || v['$tooltip-bg'];
	  v['$popover-inner-padding'] = u['$popover-inner-padding'] || '1px';
	  v['$popover-bg'] = u['$popover-bg'] || v['$white'];
	  v['$popover-max-width'] = u['$popover-max-width'] || '276px';
	  v['$popover-border-width'] = u['$popover-border-width'] || v['$border-width'];
	  v['$popover-border-color'] = u['$popover-border-color'] || color(v['$black']).alpha(0.2).toString();
	  v['$popover-box-shadow'] = u['$popover-box-shadow'] || '0 5px 10px ' + color(v['$black']).alpha(0.2).toString();
	  v['$popover-title-bg'] = u['$popover-title-bg'] || color(v['$popover-bg']).darken(0.03).toString();
	  v['$popover-title-padding-x'] = u['$popover-title-padding-x'] || '14px';
	  v['$popover-title-padding-y'] = u['$popover-title-padding-y'] || '8px';
	  v['$popover-content-padding-x'] = u['$popover-content-padding-x'] || '14px';
	  v['$popover-content-padding-y'] = u['$popover-content-padding-y'] || '9px';
	  v['$popover-arrow-width'] = u['$popover-arrow-width'] || '10px';
	  v['$popover-arrow-color'] = u['$popover-arrow-color'] || v['$popover-bg'];
	  detectedUnit = detectUnit(v['$popover-arrow-width']);
	  v['$popover-arrow-outer-width'] = u['$popover-arrow-outer-width'] || rmUnit(v['$popover-arrow-width'], detectedUnit) + 1 + detectedUnit;
	  v['$popover-arrow-outer-color'] = u['$popover-arrow-outer-color'] || color(v['$popover-border-color']).fade(0.5).toString();
	  v['$badge-default-bg'] = u['$badge-default-bg'] || v['$gray-light'];
	  v['$badge-primary-bg'] = u['$badge-primary-bg'] || v['$brand-primary'];
	  v['$badge-success-bg'] = u['$badge-success-bg'] || v['$brand-success'];
	  v['$badge-info-bg'] = u['$badge-info-bg'] || v['$brand-info'];
	  v['$badge-warning-bg'] = u['$badge-warning-bg'] || v['$brand-warning'];
	  v['$badge-danger-bg'] = u['$badge-danger-bg'] || v['$brand-danger'];
	  v['$badge-color'] = u['$badge-color'] || v['$white'];
	  v['$badge-link-hover-color'] = u['$badge-link-hover-color'] || v['$white'];
	  v['$badge-font-size'] = u['$badge-font-size'] || '75%';
	  v['$badge-font-weight'] = u['$badge-font-weight'] || v['$font-weight-bold'];
	  v['$badge-padding-x'] = u['$badge-padding-x'] || '.4em';
	  v['$badge-padding-y'] = u['$badge-padding-y'] || '.25em';
	  v['$badge-pill-padding-x'] = u['$badge-pill-padding-x'] || '.6em';
	  v['$badge-pill-border-radius'] = u['$badge-pill-border-radius'] || '10rem';
	  v['$modal-inner-padding'] = u['$modal-inner-padding'] || '15px';
	  v['$modal-dialog-margin'] = u['$modal-dialog-margin'] || '10px';
	  v['$modal-dialog-sm-up-margin-y'] = u['$modal-dialog-sm-up-margin-y'] || '30px';
	  v['$modal-title-line-height'] = u['$modal-title-line-height'] || v['$line-height-base'];
	  v['$modal-content-bg'] = u['$modal-content-bg'] || v['$white'];
	  v['$modal-content-border-color'] = u['$modal-content-border-color'] || color(v['$black']).alpha(0.2).toString();
	  v['$modal-content-border-width'] = u['$modal-content-border-width'] || v['$border-width'];
	  v['$modal-content-xs-box-shadow'] = u['$modal-content-xs-box-shadow'] || '0 3px 9px ' + color(v['$black']).alpha(0.5).toString();
	  v['$modal-content-sm-up-box-shadow'] = u['$modal-content-sm-up-box-shadow'] || '0 5px 15px ' + color(v['$black']).alpha(0.5).toString();
	  v['$modal-backdrop-bg'] = u['$modal-backdrop-bg'] || v['$black'];
	  v['$modal-backdrop-opacity'] = u['$modal-backdrop-opacity'] || '.5';
	  v['$modal-header-border-color'] = u['$modal-header-border-color'] || v['$gray-lighter'];
	  v['$modal-footer-border-color'] = u['$modal-footer-border-color'] || v['$modal-header-border-color'];
	  v['$modal-header-border-width'] = u['$modal-header-border-width'] || v['$modal-content-border-width'];
	  v['$modal-footer-border-width'] = u['$modal-footer-border-width'] || v['$modal-header-border-width'];
	  v['$modal-header-padding'] = u['$modal-header-padding'] || '15px';
	  v['$modal-lg'] = u['$modal-lg'] || '800px';
	  v['$modal-md'] = u['$modal-md'] || '500px';
	  v['$modal-sm'] = u['$modal-sm'] || '300px';
	  v['$modal-transition'] = u['$modal-transition'] || 'transform .3s ease-out';
	  v['$alert-padding-x'] = u['$alert-padding-x'] || '1.25rem';
	  v['$alert-padding-y'] = u['$alert-padding-y'] || '.75rem';
	  v['$alert-margin-bottom'] = u['$alert-margin-bottom'] || v['$spacer-y'];
	  v['$alert-border-radius'] = u['$alert-border-radius'] || v['$border-radius'];
	  v['$alert-link-font-weight'] = u['$alert-link-font-weight'] || v['$font-weight-bold'];
	  v['$alert-border-width'] = u['$alert-border-width'] || v['$border-width'];
	  v['$alert-success-bg'] = u['$alert-success-bg'] || v['$state-success-bg'];
	  v['$alert-success-text'] = u['$alert-success-text'] || v['$state-success-text'];
	  v['$alert-success-border'] = u['$alert-success-border'] || v['$state-success-border'];
	  v['$alert-info-bg'] = u['$alert-info-bg'] || v['$state-info-bg'];
	  v['$alert-info-text'] = u['$alert-info-text'] || v['$state-info-text'];
	  v['$alert-info-border'] = u['$alert-info-border'] || v['$state-info-border'];
	  v['$alert-warning-bg'] = u['$alert-warning-bg'] || v['$state-warning-bg'];
	  v['$alert-warning-text'] = u['$alert-warning-text'] || v['$state-warning-text'];
	  v['$alert-warning-border'] = u['$alert-warning-border'] || v['$state-warning-border'];
	  v['$alert-danger-bg'] = u['$alert-danger-bg'] || v['$state-danger-bg'];
	  v['$alert-danger-text'] = u['$alert-danger-text'] || v['$state-danger-text'];
	  v['$alert-danger-border'] = u['$alert-danger-border'] || v['$state-danger-border'];
	  v['$progress-height'] = u['$progress-height'] || '1rem';
	  v['$progress-font-size'] = u['$progress-font-size'] || '.75rem';
	  v['$progress-bg'] = u['$progress-bg'] || v['$gray-lighter'];
	  v['$progress-border-radius'] = u['$progress-border-radius'] || v['$border-radius'];
	  v['$progress-box-shadow'] = u['$progress-box-shadow'] || 'inset 0 .1rem .1rem ' + color(v['$black']).alpha(0.1).toString();
	  v['$progress-bar-color'] = u['$progress-bar-color'] || v['$white'];
	  v['$progress-bar-bg'] = u['$progress-bar-bg'] || v['$brand-primary'];
	  v['$progress-bar-animation-timing'] = u['$progress-bar-animation-timing'] || '1s linear infinite';
	  v['$list-group-color'] = u['$list-group-color'] || v['$body-color'];
	  v['$list-group-bg'] = u['$list-group-bg'] || v['$white'];
	  v['$list-group-border-color'] = u['$list-group-border-color'] || color(v['$black']).alpha(0.125).toString();
	  v['$list-group-border-width'] = u['$list-group-border-width'] || v['$border-width'];
	  v['$list-group-border-radius'] = u['$list-group-border-radius'] || v['$border-radius'];
	  v['$list-group-item-padding-x'] = u['$list-group-item-padding-x'] || '1.25rem';
	  v['$list-group-item-padding-y'] = u['$list-group-item-padding-y'] || '.75rem';
	  v['$list-group-hover-bg'] = u['$list-group-hover-bg'] || v['$gray-lightest'];
	  v['$list-group-active-color'] = u['$list-group-active-color'] || v['$component-active-color'];
	  v['$list-group-active-bg'] = u['$list-group-active-bg'] || v['$component-active-bg'];
	  v['$list-group-active-border'] = u['$list-group-active-border'] || v['$list-group-active-bg'];
	  v['$list-group-disabled-color'] = u['$list-group-disabled-color'] || v['$gray-light'];
	  v['$list-group-disabled-bg'] = u['$list-group-disabled-bg'] || v['$list-group-bg'];
	  v['$list-group-link-color'] = u['$list-group-link-color'] || v['$gray'];
	  v['$list-group-link-hover-color'] = u['$list-group-link-hover-color'] || v['$list-group-link-color'];
	  v['$list-group-link-active-color'] = u['$list-group-link-active-color'] || v['$list-group-color'];
	  v['$list-group-link-active-bg'] = u['$list-group-link-active-bg'] || v['$gray-lighter'];
	  v['$thumbnail-padding'] = u['$thumbnail-padding'] || '.25rem';
	  v['$thumbnail-bg'] = u['$thumbnail-bg'] || v['$body-bg'];
	  v['$thumbnail-border-width'] = u['$thumbnail-border-width'] || v['$border-width'];
	  v['$thumbnail-border-color'] = u['$thumbnail-border-color'] || '#ddd';
	  v['$thumbnail-border-radius'] = u['$thumbnail-border-radius'] || v['$border-radius'];
	  v['$thumbnail-box-shadow'] = u['$thumbnail-box-shadow'] || '0 1px 2px ' + color(v['$black']).alpha(0.75).toString();
	  v['$thumbnail-transition'] = u['$thumbnail-transition'] || 'all .2s ease-in-out';
	  v['$figure-caption-font-size'] = u['$figure-caption-font-size'] || '90%';
	  v['$figure-caption-color'] = u['$figure-caption-color'] || v['$gray-light'];
	  v['$breadcrumb-padding-y'] = u['$breadcrumb-padding-y'] || '.75rem';
	  v['$breadcrumb-padding-x'] = u['$breadcrumb-padding-x'] || '1rem';
	  v['$breadcrumb-item-padding'] = u['$breadcrumb-item-padding'] || '.5rem';
	  v['$breadcrumb-bg'] = u['$breadcrumb-bg'] || v['$gray-lighter'];
	  v['$breadcrumb-divider-color'] = u['$breadcrumb-divider-color'] || v['$gray-light'];
	  v['$breadcrumb-active-color'] = u['$breadcrumb-active-color'] || v['$gray-light'];
	  v['$breadcrumb-divider'] = u['$breadcrumb-divider'] || '"/"';
	  v['$close-font-size'] = u['$close-font-size'] || rmUnit(v['$font-size-base']) * 1.5 + detectUnit(v['$font-size-base']);
	  v['$close-font-weight'] = u['$close-font-weight'] || v['$font-weight-bold'];
	  v['$close-color'] = u['$close-color'] || v['$black'];
	  v['$close-text-shadow'] = u['$close-text-shadow'] || '0 1px 0 ' + v['$white'];
	  v['$code-font-size'] = u['$code-font-size'] || '90%';
	  v['$code-padding-x'] = u['$code-padding-x'] || '.4rem';
	  v['$code-padding-y'] = u['$code-padding-y'] || '.2rem';
	  v['$code-color'] = u['$code-color'] || '#bd4147';
	  v['$code-bg'] = u['$code-bg'] || v['$gray-lightest'];
	  v['$kbd-color'] = u['$kbd-color'] || v['$white'];
	  v['$kbd-bg'] = u['$kbd-bg'] || v['$gray-dark'];
	  v['$pre-color'] = u['$pre-color'] || v['$gray-dark'];
	  v['$pre-scrollable-max-height'] = u['$pre-scrollable-max-height'] || '340px';
	  return Object.assign({}, u, v);
	}

	var makeThemeList = [makeOriginal];
	function makeTheme(list, theme) {
	  if (!Array.isArray(list)) {
	    theme = list;
	    list = makeThemeList;
	  }
	  var all = [].concat(list);
	  var t = theme;
	  var mt = void 0;
	  while (mt = all.shift()) {
	    t = mt(t);
	  }
	  return t;
	}
	var theme = makeTheme();

	var defineProperty = function (obj, key, value) {
	  if (key in obj) {
	    Object.defineProperty(obj, key, {
	      value: value,
	      enumerable: true,
	      configurable: true,
	      writable: true
	    });
	  } else {
	    obj[key] = value;
	  }

	  return obj;
	};

	var _extends = Object.assign || function (target) {
	  for (var i = 1; i < arguments.length; i++) {
	    var source = arguments[i];

	    for (var key in source) {
	      if (Object.prototype.hasOwnProperty.call(source, key)) {
	        target[key] = source[key];
	      }
	    }
	  }

	  return target;
	};

	var toMakeTheme = function toMakeTheme(theme) {
	  return function (userTheme) {
	    return _extends({}, theme, userTheme);
	  };
	};
	var toMakeScopedTheme = function toMakeScopedTheme(theme) {
	  return function (userTheme) {
	    var result = {};
	    Object.keys(theme).forEach(function (key) {
	      return result = defineProperty({}, key, _extends({}, theme[key], userTheme));
	    });
	    return result;
	  };
	};
	function makeThemeFromList(list, theme) {
	  var all = [].concat(list);
	  var t = theme;
	  var mt = void 0;
	  while (mt = all.pop()) {
	    t = mt(t);
	  }
	  return t;
	}
	function createMakeTheme(list) {
	  return function (theme) {
	    return makeThemeFromList(list, theme);
	  };
	}
	function makeScopedTheme() {
	  var userTheme = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defineProperty({}, scopeName, {});
	  var scopeName = arguments[1];
	  if (scopeName === undefined) return console.warn('You may have forgotten to set the scope name in the makeScopedTheme function.');
	  var newTheme = defineProperty({}, scopeName, {});
	  var v = newTheme[scopeName];
	  var u = userTheme[scopeName] || {};
	  Object.keys(userTheme).forEach(function (variable) {
	    v[variable] = u[variable] || userTheme[variable];
	  });
	  return defineProperty({}, scopeName, _extends({}, userTheme, v));
	}

	var reboot = createCommonjsModule(function (module, exports) {
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.getGlobalStyles = getGlobalStyles;
	exports.getGlobalStyleNoBootstrapProvider = getGlobalStyleNoBootstrapProvider;
	exports.html = html;
	exports.boxSizing = boxSizing;
	exports.ie10FixViewport = ie10FixViewport;
	exports.body = body;
	exports.bodyUtils = bodyUtils;
	exports.tabIndex = tabIndex;
	exports.svg = svg;
	exports.ie10FixHidden = ie10FixHidden;
	exports.webkitFileUploadButton = webkitFileUploadButton;
	var defaultProps = exports.defaultProps = {
	  '$font-family-base': '-apple-system, system-ui, BlinkMacSystemFont, "Segoe UI", Roboto, "Helvetica Neue", Arial, sans-serif',
	  '$font-size-base': '1rem',
	  '$font-weight-base': '1.5',
	  '$line-height-base': '1.5',
	  '$body-color': '#292b2c',
	  '$body-bg': '#fff'
	};
	function getGlobalStyles() {
	  return '\n    html {\n      ' + html() + '\n    }\n    *,\n    *::before,\n    *::after {\n      ' + boxSizing() + '\n    }\n    @-ms-viewport { \n      ' + ie10FixViewport() + ' \n    }\n    body {\n      ' + bodyUtils() + '\n    }\n  ';
	}
	function getGlobalStyleNoBootstrapProvider() {
	  var fontFamilyBase = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultProps['$font-family-base'];
	  var fontSizeBase = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultProps['$font-size-base'];
	  var fontWeightBase = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : defaultProps['$font-weight-base'];
	  var lineHeightBase = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : defaultProps['$line-height-base'];
	  var bodyColor = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : defaultProps['$body-color'];
	  var bodyBg = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : defaultProps['$body-bg'];
	  return '\n  ' + getGlobalStyles() + '\n  body {\n  ' + body(fontFamilyBase, fontSizeBase, fontWeightBase, lineHeightBase, bodyColor, bodyBg) + ' \n}';
	}
	function html() {
	  return '\n    box-sizing: border-box;\n    font-family: sans-serif;\n    line-height: 1.15;\n    -ms-text-size-adjust: 100%;\n    -webkit-text-size-adjust: 100%;\n    -ms-overflow-style: scrollbar;\n    -webkit-tap-highlight-color: rgba(0,0,0,0);\n  ';
	}
	function boxSizing() {
	  return '\n    box-sizing: inherit;\n  ';
	}
	function ie10FixViewport() {
	  return '\n    width: device-width;\n  ';
	}
	function body() {
	  var fontFamilyBase = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultProps['$font-family-base'];
	  var fontSizeBase = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultProps['$font-size-base'];
	  var fontWeightBase = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : defaultProps['$font-weight-base'];
	  var lineHeightBase = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : defaultProps['$line-height-base'];
	  var bodyColor = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : defaultProps['$body-color'];
	  var bodyBg = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : defaultProps['$body-bg'];
	  return '\n    margin: 0;\n    font-family: ' + fontFamilyBase + ';\n    font-size: ' + fontSizeBase + ';\n    font-weight: ' + fontWeightBase + ';\n    line-height: ' + lineHeightBase + ';\n    color: ' + bodyColor + ';\n    background-color: ' + bodyBg + ';\n    \n    ' + bodyUtils() + '\n    \n    [tabindex="-1"]:focus {\n      ' + tabIndex() + '\n    }\n    svg:not(:root) {\n      ' + svg() + '\n    }\n    [hidden] {\n      ' + ie10FixHidden() + '\n    }\n    ::-webkit-file-upload-button {\n      ' + webkitFileUploadButton() + '\n    }\n  ';
	}
	function bodyUtils() {
	  return '\n    &.overflow {\n      overflow: hidden;\n    }\n  ';
	}
	function tabIndex() {
	  return '\n    outline: none !important;\n  ';
	}
	function svg() {
	  return '\n    overflow: hidden;\n  ';
	}
	function ie10FixHidden() {
	  return '\n    display: none !important;\n  ';
	}
	function webkitFileUploadButton() {
	  return '\n    font: inherit;\n    -webkit-appearance: button;\n  ';
	}
	exports.default = {
	  html: html,
	  boxSizing: boxSizing,
	  ie10FixViewport: ie10FixViewport,
	  body: body,
	  bodyUtils: bodyUtils,
	  tabIndex: tabIndex,
	  svg: svg,
	  ie10FixHidden: ie10FixHidden,
	  getGlobalStyles: getGlobalStyles,
	  getGlobalStyleNoBootstrapProvider: getGlobalStyleNoBootstrapProvider,
	  webkitFileUploadButton: webkitFileUploadButton
	};
	});
	unwrapExports(reboot);
	var reboot_1 = reboot.getGlobalStyles;
	var reboot_2 = reboot.getGlobalStyleNoBootstrapProvider;
	var reboot_3 = reboot.html;
	var reboot_4 = reboot.boxSizing;
	var reboot_5 = reboot.ie10FixViewport;
	var reboot_6 = reboot.body;
	var reboot_7 = reboot.bodyUtils;
	var reboot_8 = reboot.tabIndex;
	var reboot_9 = reboot.svg;
	var reboot_10 = reboot.ie10FixHidden;
	var reboot_11 = reboot.webkitFileUploadButton;
	var reboot_12 = reboot.defaultProps;

	exports.theme = theme;
	exports.makeTheme = makeTheme;
	exports.createMakeTheme = createMakeTheme;
	exports.makeScopedTheme = makeScopedTheme;
	exports.toMakeTheme = toMakeTheme;
	exports.toMakeScopedTheme = toMakeScopedTheme;
	exports.getGlobalStyles = reboot_1;
	exports.getGlobalStyleNoBootstrapProvider = reboot_2;

	Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=bootstrap-styled.js.map
